appCtrl

  .controller('ActivitiesAndServicesCtrl', function ($rootScope, $scope, GetInfo, $state, searchPlaceholder, popup, getOrder, $ionicPopup, $interval, User) {
    $rootScope.clearBadge();
    $scope.playgroundInfo = [];
    $scope.newPlaygroundInfo = [];
    $rootScope.pageCode = "hdyfw";
    //活动报名
    $scope.payActivity = function (info) {
      var temp = JSON.parse(JSON.stringify(info));
      temp.id = temp.courseid;
      popup.activityAgreementPopup($scope).then(function (res) {
        if (res) {
          popup.studentsPopup($scope).then(function (res) {
            if (info.act_price == 0) {
              getOrder.activityOrder(res, {id: info.courseid}).$promise.then(function (res) {
                $ionicPopup.alert({
                  template: res.msgDesc,
                  okText: '关闭'
                })
              }).catch(function () {
                $rootScope.showNetworkAnomalyToastMessage();
              })
            } else {
              $scope.payName = "活动";
              popup.selectPayMethod($scope, res, temp).then(function (fnc) {
                if (fnc) fnc("activityOrder"); // activityOrder 活动订单 courseOrder 课程订单
              });
            }
          })
        }
      })

    };
    //搜索插件
    $scope.placeholder = searchPlaceholder;
    $scope.onSearch = function (search) {
      $state.go('tab.activitiesAndServices-searchPage', {
        params: ''
      });
      if (event.which === 13) {
        $state.go('tab.activitiesAndServices-searchPage', {
          params: search
        })
      }
    };
    //下拉刷新
    $scope.doRefresh = function () {
      $rootScope.clearBadge();
      GetInfo.query("hd").$promise.then(function (res) {
        $scope.playgroundInfo = res;
        $scope.snapshot = JSON.parse(JSON.stringify(res));

        //时间实效性过滤
        function filterTime() {
          $scope.playgroundInfo.forEach(function (item, index) {
            item.push_date = moment($scope.snapshot[index].push_date).from(moment());
          })
        }

        //结束之前的轮询建立新的
        if ($rootScope.twTimeline) {
          $interval.cancel($rootScope.twTimeline);
        }
        filterTime();
        $rootScope.twTimeline = $interval(function () {
          filterTime();
        }, 60000);
      }).catch(function () {
        if (User.getCurrentUserId()) {
          $rootScope.showNetworkAnomalyToastMessage();
        }
      }).finally(function () {
        $scope.$broadcast('scroll.refreshComplete')
      });
    };
    //上拉加载数据
    $scope.loadMore = function () {
      GetInfo.query("hd", $scope.playgroundInfo[$scope.playgroundInfo.length - 1].id).$promise.then(function (res) {
        $scope.newPlaygroundInfo = res;
        $scope.playgroundInfo = $scope.playgroundInfo.concat($scope.newPlaygroundInfo);
        $scope.snapshot = JSON.parse(JSON.stringify([$scope.snapshot].concat(res)));

        //时间实效性过滤
        function filterTime() {
          $scope.playgroundInfo.forEach(function (item, index) {
            item.push_date = moment($scope.snapshot[index].push_date).from(moment());
          })
        }

        //结束之前的轮询建立新的
        if ($rootScope.twTimeline) {
          $interval.cancel($rootScope.twTimeline);
        }
        filterTime();
        $rootScope.twTimeline = $interval(function () {
          filterTime();
        }, 60000);
      }).catch(function () {
        if (User.getCurrentUserId()) {
          $rootScope.showNetworkAnomalyToastMessage();
        }
      }).finally(function () {
        $scope.$broadcast('scroll.infiniteScrollComplete')
      });
    };


    $scope.doRefresh();
  })
  //未参加活动
  .controller('WCJActivitiesListCtrl', function ($scope, getWCJActivities, $rootScope, $ionicHistory, $state) {

    //返回上一个页面
    $scope.goBack = function() {
      $state.go("tab.activitiesAndServices");
    };
    $rootScope.pageCode = "wcjhdlb";

    function init() {
      $scope.loading = true;

      getWCJActivities.query().$promise.then(function (res) {
        $scope.WCJActivities = res;
        $scope.OldWCJActivities = res;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
      });
    }

    init()

    function getResult(val) {
      if (!$scope.OldWCJActivities.length) return [];
      return $scope.OldWCJActivities.filter(function (item) {
        return item.msg.indexOf(val) > -1;
      })
    }

    $scope.onSearch = function (search) {
      if (event.which === 13) {
        if (search) {
          $scope.WCJActivities = getResult(search)
        } else {
          init()
        }
      }
    };
  })
  //已参加活动
  .controller('YCJActivitiesListCtrl', function ($scope, getYCJActivities, $rootScope, $ionicHistory, $state) {

    //返回上一个页面
    $scope.goBack = function() {
      $state.go("tab.activitiesAndServices");
    };
    $rootScope.pageCode = "ycjhdlb";

    function init() {
      $scope.loading = true;

      getYCJActivities.query().$promise.then(function (res) {
        $scope.YCJActivities = res;
        $scope.OldYCJActivities = res;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
      });
    }

    init();

    function getResult(val) {
      if (!$scope.OldYCJActivities.length) return [];
      return $scope.OldYCJActivities.filter(function (item) {
        return item.msg.indexOf(val) > -1;
      })
    }

    $scope.onSearch = function (search) {
      if (event.which === 13) {
        if (search) {
          $scope.YCJActivities = getResult(search);
        } else {
          init();
        }
      }
    };
  })
  //活动推荐
  .controller('HDTJPageCtrl', function ($scope, getHD, $rootScope, $ionicHistory) {
    $scope.currentView = $ionicHistory.currentView().url.split('/')[2];
    $rootScope.pageCode = "hdtjlb";
    $scope.loading = true;

    getHD.query().$promise.then(function (res) {
      $scope.HDInfo = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })

  //活动详情
  .controller('HDXQPageCtrl', function ($scope, $stateParams, getActivityClientMessageist, $rootScope, popup, getOrder, $ionicPopup, GetInfo) {
    $rootScope.pageCode = "hdtjxq";
    $scope.activitiesInfo = $stateParams.params;
    $scope.loading = true;
    //支付
    $scope.pay = function (info) {
      popup.activityAgreementPopup($scope).then(function (res) {
        if (res) {
          popup.studentsPopup($scope).then(function (res) {
            if (info.other.act_price == 0) {
              getOrder.activityOrder(res, info).$promise.then(function (res) {
                $ionicPopup.alert({
                  template: res.msgDesc,
                  okText: '关闭'
                })
              }).catch(function () {
                $rootScope.showNetworkAnomalyToastMessage();
              })
            } else {
              $scope.payName = "活动";
              popup.selectPayMethod($scope, res, info).then(function (fnc) {
                if (fnc) fnc("activityOrder"); // activityOrder 活动订单 courseOrder 课程订单
              });
            }
          })
        }
      })

    };

    GetInfo.updateTWRead($scope.activitiesInfo.id);
    getActivityClientMessageist.query($scope.activitiesInfo.id).$promise.then(function (res) {
      $scope.HDXQInfo = res[0];
      $rootScope.toPushtitle = res[0].title;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('CJHDPageCtrl', function ($scope, $stateParams, $rootScope, getAppActivityInfo, $ionicHistory) {

    //返回上一个页面
    $scope.goBack = function() {
      $ionicHistory.goBack();
    };

    $rootScope.pageCode = "ycjhdxq";
    $scope.activitiesInfo = $stateParams.params;
    $scope.loading = true;
    $scope.openVideo = function (video) {
      window.open(video.path, '_blank', 'location=yes')
    };
    getAppActivityInfo.query($scope.activitiesInfo.id).$promise.then(function (res) {
      $rootScope.toPushtitle = res[0].act_name;
      var studentItem = [];
      res.filter(function (item) {
        return item.student_id != null;
      }).forEach(function (item) {
        if (item.atts_info != null) {
          studentItem = studentItem.concat(JSON.parse(item.atts_info));
        }
      });
      var noStudentItem = [];
      res.filter(function (item) {
        return item.student_id == null;
      }).forEach(function (item) {
        if (item.atts_info != null) {
          noStudentItem = noStudentItem.concat(JSON.parse(item.atts_info));
        }
      });
      var studentPhotos = studentItem.filter(function (item) {
        return item.fileType !== 'video';
      });
      var noStudentPhotos = noStudentItem.filter(function (item) {
        return item.fileType !== 'video';
      });
      $scope.photos = studentPhotos.concat(noStudentPhotos);
      var studentVideos = studentItem.filter(function (item) {
        return item.fileType === 'video';
      });
      var noStudentVideos = noStudentItem.filter(function (item) {
        return item.fileType === 'video';
      });
      $scope.videos = studentVideos.concat(noStudentVideos);
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
;
