// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
//初始化monent对象

moment.locale('zh-cn', {
  relativeTime: {
    future: "%s",
    past: "%s",
    s: "刚刚",
    m: "1分钟前",
    mm: "%d 分钟前",
    h: "1小时前",
    hh: "%d 小时前",
    d: "1天前",
    dd: "%d 天前",
    M: "1个月前",
    MM: "%d 月前",
    y: "1年前",
    yy: "%d 年前"
  }
});
angular.module('starter', ['ngResource', 'ionic', 'starter.controllers', 'starter.services', 'ionic.native', 'ngAnimate', 'ui.calendar'])

// //延时加载
//   .constant('$ionicLoadingConfig', {
//     template: '<ion-spinner icon="ios" class=""></ion-spinner>',
//     animation: 'fade-in',
//     duration: 10000//等待10秒后自动隐藏指示器
//   })

  .run(function (getStudentInfo, $cordovaClipboard, getUnReadCount, $cordovaAppVersion, updateApp, $cordovaDevice, ENV, Storage, $interval, $ionicPlatform, $timeout, $cordovaSplashscreen, $state, $ionicHistory, $rootScope, $cordovaToast, User, saveAppActivities, $filter, getQuestionnaire, GetInfo, $window, $ionicPopup, $cordovaStatusBar) {
    //防止初始密码,初始信息必需修改绕过
    User.getCurrentUser().then(function (res) {
      if (res && res.isOrginalPsw) {
        $ionicPopup.confirm({
          template: '初始密码需要修改!',
          cancelText: '退出登入',
          cancelType: 'assertive-important',
          okText: '去修改',
          okType: 'button-positive'
        }).then(function (res) {
          if (res) {
            $state.go('tab.personal').then(function () {
              $ionicHistory.nextViewOptions({
                historyRoot: true
              });
              $state.go('tab.personal-changePassword', {
                params: {
                  id: User.getCurrentUserId()
                }
              }).then(function () {
                User.logout();
              });
            });

          } else {
            User.logout();
            $ionicHistory.nextViewOptions({
              historyRoot: true
            });
            $state.go('login');
          }
        });
      } else {
        getStudentInfo.query().$promise.then(function (res) {
          $rootScope.changeInfo = {};
          $rootScope.changeInfo.studentInfo = res;
          $rootScope.changeInfo.studentInfo = $rootScope.changeInfo.studentInfo.map(function (item) {
            item.brithday = new Date(item.brithday);
            return item;
          });

          function validInfo() {
            for (var i = 0; i < $rootScope.changeInfo.studentInfo.length; i++) {
              var info = $rootScope.changeInfo.studentInfo[i];
              if (!(info.name && info.brithday && info.mobile)) {
                return false
              }
            }
          }

          if (validInfo() === false) {
            $ionicPopup.confirm({
              template: '初始信息需要修改!',
              cancelText: '退出登录',
              cancelType: 'assertive-important',
              okText: '去修改',
              okType: 'button-positive'
            }).then(function (res) {
              if (res) {
                $ionicModal.fromTemplateUrl('templates/changeInfo.html', {
                  scope: $rootScope,
                  animation: 'slide-in-up'
                }).then(function (modal) {
                  $rootScope.changeInfo.modal = modal;
                  $rootScope.changeInfo.modal.show();
                  $rootScope.changeInfo.closeModal = function () {
                    $rootScope.changeInfo.modal.hide();
                    User.logout();
                    $ionicHistory.nextViewOptions({
                      historyRoot: true
                    });
                    $state.go('login');
                  };
                  $rootScope.changeInfo.save = function () {
                    if (validInfo() === false) {
                      $ionicPopup.alert({
                        template: '带*必填!'
                      })
                    } else {
                      var edit = function (info) {
                        var thePromise = getStudentInfo.save(info).$promise;
                        thePromise.catch(function (err) {
                          $rootScope.showToastMessage(info.name + err.msgDesc)
                        });
                        return thePromise;
                      };
                      Promise.all($rootScope.changeInfo.studentInfo.map(function (info) {
                        return edit(info);
                      })).then(function () {
                        $rootScope.changeInfo.modal.hide();
                        $rootScope.showToastMessage('保存成功');
                      });
                    }
                  };
                });
              } else {
                User.logout();
                $ionicHistory.nextViewOptions({
                  historyRoot: true
                });
                $state.go('login');
              }
            })
          }
        }).catch(function () {
          $rootScope.showNetworkAnomalyToastMessage();
        }).finally(function () {
          $rootScope.changeInfo.loading = false;
        });

      }
    });

    //时间轮询对象
    $rootScope.timeline = null;
    $rootScope.twTimeline = null;

    $rootScope.initUnRead = function () {
      getUnReadCount.get().$promise.then(function (res) {
        if (res.count) {
          $rootScope.UnReadcount = res.count;
        } else {
          $rootScope.UnReadcount = 0;
        }
      });
    };


    $rootScope.initUnRead();

    //暂时无用
    function initBadge() {
      $rootScope.badge = {
        "tw": {
          'kc': 0,
          'fmkc': 0,
          'hd': 0,
          'lydt': 0
        },
        'kqtz': 0,
        "kq": 0,
        "sksjxg": 0,
        "bk": 0,
        "sk": 0,
        "wj": 0,
        "lyhf": 0
      };
      $rootScope.pageBadgeLength = {
        home: 0,
        courses: 0,
        activitiesAndServices: 0
      };
    }

    initBadge();

    $rootScope.options = {
      autoplay: 3000,
      effect: 'coverflow',
      loop: true,
      autoplayDisableOnInteraction: false
    };
    $rootScope.chineseNumber = ["零", "一", "二", "三", "四", "五", "六", "日", "八", "九", "十"];
    $rootScope.imgPath = ENV.imgpath;

    /*   $rootScope.loading = function () {
         $ionicLoading.show({
           templateUrl: "templates/loading.html"
         });
       };*/

    function getParams() {
      for (var item in $state.params) {
        if ($state.params[item]) {
          return $state.params[item];
        }
      }
      return {};
    }

    var dwellTime = 0;
    var pageDwekkTimeInterval;
    var oldPageDwellTime = Storage.get("pageDwellTime");

    function dateFormat(date) {
      return $filter('date')(date, 'yyyy-MM-dd HH:mm:ss');
    }

    var openTime;
    var closeTime;

    if (oldPageDwellTime) {
      saveAppActivities.save(oldPageDwellTime);
      $rootScope.adId = null;
      Storage.remove('pageDwellTime');
    }
    $rootScope.phone = {
      uuid: $cordovaDevice.uuid || null,
      model: $cordovaDevice.model || null,
      serial: $cordovaDevice.serial || null
    };

    function updateDwellTime() {
      dwellTime++;
      Storage.set('pageDwellTime', {
        time: dwellTime,
        uuid: $rootScope.phone.uuid,
        model: $rootScope.phone.model,
        serial: $rootScope.phone.serial,
        User: User.getLoginId(),
        bussinessId: getParams().id ? getParams().id : $rootScope.adId,
        pageCode: $rootScope.pageCode,
        openTime: dateFormat(openTime)
      });

    }

//计算badge
    function countBadge(pageName, array) {
      var temp = 0;
      var badgeKey;
      for (badgeKey in $rootScope.badge) {
        if (array && array.length && (array.indexOf(badgeKey) >= 0)) continue;
        if (badgeKey === 'tw') {
          var twKey;
          for (twKey in $rootScope.badge[badgeKey]) {
            temp += $rootScope.badge[badgeKey][twKey];
          }
        } else {
          temp += $rootScope.badge[badgeKey];
        }
      }
      $rootScope.pageBadgeLength[pageName] = temp;
    }

    //清空对应badge array中的不清除
    $rootScope.clearBadge = function (array) {
      var badgeKey;
      for (badgeKey in $rootScope.badge) {
        if (array && array.length && (array.indexOf(badgeKey) >= 0)) continue;
        if (badgeKey === 'tw') {
          var twKey;
          for (twKey in $rootScope.badge[badgeKey]) {
            $rootScope.badge[badgeKey][twKey] = 0;
          }
        } else {
          $rootScope.badge[badgeKey] = 0;
        }
      }
      countBadge('home');
      countBadge('courses', ['hd']);
      countBadge('activitiesAndServices');
    };


    document.addEventListener('resume', function () {
      pageDwekkTimeInterval = $interval(updateDwellTime, 1000);
    });
    document.addEventListener('pause', function () {
      $interval.cancel(pageDwekkTimeInterval);
    });
    $rootScope.$on('$ionicView.enter', function () {
      if (getParams().id == null || getParams() == null) {
        $rootScope.toPushtitle = null;
      }
      openTime = new Date();
 /*     var pageDwellTime = Storage.get('pageDwellTime');
      if (pageDwellTime) {
        closeTime = new Date();
        pageDwellTime.closeTime = dateFormat(closeTime);
        $interval.cancel(pageDwekkTimeInterval);
        saveAppActivities.save(pageDwellTime);
        $rootScope.adId = null;
        Storage.remove('pageDwellTime')
      }*/
      dwellTime = 0;
      pageDwekkTimeInterval = $interval(updateDwellTime, 1000);
    });
    $rootScope.$on('$ionicView.beforeLeave', function () {
      var pageDwellTime = Storage.get('pageDwellTime');
      closeTime = new Date();
      if (!pageDwellTime) {
        pageDwellTime = {
          time: 0,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          User: User.getLoginId(),
          bussinessId: getParams().id ? getParams().id : $rootScope.adId,
          pageCode: $rootScope.pageCode,
          openTime: dateFormat(openTime)
        };
      }
      pageDwellTime.closeTime = dateFormat(closeTime);
      pageDwellTime.title = $rootScope.toPushtitle || null;
      $rootScope.adId = null;
      $interval.cancel(pageDwekkTimeInterval);
      // console.log(Storage.get('pageDwellTime'));
      //发送行为日志
      saveAppActivities.save(pageDwellTime);
      Storage.remove('pageDwellTime')
    });
    $rootScope.verifyMessage = function () {
      if (!$rootScope.isLogin) {
        /*   $ionicHistory.nextViewOptions({
             historyRoot: true
           });*/
        $ionicPopup.confirm({
          template: '该功能需要登入!',
          cancelText: '取消',
          cancelType: 'bar-assertive',
          okText: '确定',
          okType: 'button-positive'
        }).then(function (res) {
          if (res) {
            $ionicHistory.nextViewOptions({
              historyRoot: true
            });
            $state.go('login');
          } else {
            $ionicHistory.goBack();
          }
        });

      }
    };
    $rootScope.clickMessage = function () {
      if (!$rootScope.isLogin) {
        /*   $ionicHistory.nextViewOptions({
             historyRoot: true
           });*/
        return $ionicPopup.confirm({
          template: '该功能需要登入!',
          cancelText: '取消',
          cancelType: 'bar-assertive',
          okText: '确定',
          okType: 'button-positive'
        }).then(function (res) {
          if (res) {
            $ionicHistory.nextViewOptions({
              historyRoot: true
            });
            $state.go('login');
            return false
          } else {
            return false
          }
        });
      } else {
        return Promise.resolve(true);
      }
    };
    $rootScope.isLogin = false;
    if (User.getCurrentUserId() == null) {
      $rootScope.isLogin = false;
    } else {
      //更新当前用户信息 暂未写
      $rootScope.isLogin = true;
    }
    $rootScope.showToastMessage = function (msg) {
      $cordovaToast.showShortCenter(msg).subscribe();
    };
    $rootScope.showNetworkAnomalyToastMessage = function () {
      $cordovaToast.showShortCenter('网络异常!').subscribe();
    };

    $rootScope.onMessage = function (info, currentTab) {
      if (!currentTab) {
        currentTab = $ionicHistory.currentView().url.split('/')[2] || "home";
      }
      info.is_read = 'y';
      GetInfo.updateRead(info.id);
      // if (info.is_read === 'f' && ionic.Platform.isIOS()) {
      //   $window.plugins.jPushPlugin.getApplicationIconBadgeNumber(function (badgeNum) {
      //     if (badgeNum > 0) {
      //       $window.plugins.jPushPlugin.setBadge(badgeNum - 1);
      //     }
      //   })
      // }
      switch (info.type) {
        case "tw":
          if (info.content) info.content = JSON.parse(info.content);
          switch (info.message_category) {
            case 'kc':
              $state.go('tab.home').then(function () {
                $state.go('tab.home-LYDTDetail', {
                  params: {
                    id: info.bussiness_id,
                    content: info.content
                  }
                });
              });
              break;
            case 'fmkc':
              $state.go('tab.home').then(function () {
                $state.go('tab.home-FMKT-HDXQPage', {
                  params: {
                    id: info.bussiness_id,
                    content: info.content
                  }
                });
              });
              break;
            case 'hd':
              $state.go('tab.' + currentTab + '-HDXQPage', {
                params: {
                  id: info.bussiness_id,
                  content: info.content
                }
              });
              break;
            case 'lydt':
              $state.go('tab.home').then(function () {
                $state.go('tab.home-LYDTDetail', {
                  params: {
                    id: info.bussiness_id,
                    content: info.content
                  }
                });
              });
              break;
            default:
              if (info.url) {
                $state.go(info.url, {
                  params: info.params
                });
              }
          }
          break;
        case 'kqtz':
          if (currentTab === 'activitiesAndServices') {
            $state.go('tab.activitiesAndServices-HDQDPage');
          } else {
            $state.go('tab.' + currentTab + '-QDQJPage');
          }
          break;
        case "kq":
          $state.go('tab.' + currentTab + '-kqjl').then(function () {
            $ionicHistory.removeBackView();
          });
          break;
        case "sksjxg":
          break;
        case "bk":
          $state.go('tab.courses').then(function () {
            var item = JSON.parse(info.push_map);
            $state.go('tab.courses-WDYDDetail', {
              params: {
                id: item.campId,
                camp_name: item.campName
              }
            });
          });
          break;
        case "sk":
          break;
        case "wj":
          getQuestionnaire.open(JSON.parse(info.push_map));
          break;
        case "lyhf":
          var item = JSON.parse(info.push_map);
          $state.go('tab.' + currentTab + '-onlineMessage', {
            params: {
              businessDesc: item.businessDesc,
              course_lesson_num: item.lessonNum,
              id: item.bussiness_id,
              camp_id: item.campId,
              type_code: item.businessType,
              lesson_id: item.lesson_id
            }
          });
          break;
        case "xzhd":
          $state.go('tab.' + currentTab + '-xzhdDetailPage', {
            params: {
              id: info.bussiness_id
            }
          });
          break;
        default:
          if (info.url) {
            $state.go(info.url, {
              params: info.params
            });
          }
      }

    };
    var backbutton = 0;
    $ionicPlatform.registerBackButtonAction(function (event) {
      if ($ionicHistory.backView() == null || ($state.current.name === "tab.home" || $state.current.name === "login")) {
        if (backbutton === 0) {
          backbutton++;
          $cordovaToast.show('再按一次返回退出!', '1500', 'bottom').subscribe();
          $timeout(function () {
            backbutton = 0;
          }, 1500)
        } else {
          navigator.app.exitApp(); //<-- remove this line to disable the exit
        }
      }
      else {
        $ionicHistory.goBack();
      }
    }, 100);

    $ionicPlatform.ready(function () {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      //延迟加载
      // $rootScope.isLoadingShow = function() {
      //   var timer = 0;
      //
      //   $timeout(function(){
      //     console.log(timer);
      //     if(timer < 30) {
      //       alert("进来了");
      //       $rootScope.loading = true;
      //       return false;
      //     } else {
      //       $cordovaToast.showShortCenter('网络异常!').subscribe();
      //     }
      //     timer++;
      //   },1000);
      // };

      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(true);
      }

      //input被键盘挡住问题
      var isIOS = !!navigator.userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //判断是iOS
      if(isIOS) {
        function keyboardShowHandler(e){
          if(window.scrollY < 100) //键盘高度一般大于100，如果scrollY小于100，可以认为界面未上移，则需要手动上移
            window.scrollTo(0, e.keyboardHeight);
        }
        function keyboardHideHandler(e){
          if(window.scrollY != 0)
            window.scrollTo(0, 0);
        }
        window.addEventListener('native.keyboardshow', keyboardShowHandler);
        window.addEventListener('native.keyboardhide', keyboardHideHandler);
      }

      /*     try {
             $cordovaKeyboard.hideKeyboardAccessoryBar(true);
             $cordovaKeyboard.disableScroll(true);
           } catch (err) {
             alert(err)
           }
           if (window.StatusBar) {
             // org.apache.cordova.statusbar required
             // StatusBar.styleDefault();
           }*/
      window.codePush.sync();
      $cordovaStatusBar.backgroundColorByHexString("#09bfee");

      updateApp.checkUpdate();
      $rootScope.phone = {
        uuid: $cordovaDevice.uuid || null,
        model: $cordovaDevice.model || null,
        serial: $cordovaDevice.serial || null
      };

      //注册alias
      User.getCurrentUser().then(function (res) {
        if (res && res.alias) {
          $window.plugins.jPushPlugin.resumePush();
          $window.plugins.jPushPlugin.setAlias({
            sequence: 1,
            alias: res.alias
          })
        }
      });


      var onJPush = function (info, currentTab) {
        info.is_read = 'y';
        GetInfo.updateRead(info.message_id);
        switch (info.type) {
          case "tw":
            if (info.content) info.content = JSON.parse(info.content);
            switch (info.message_category) {
              case 'kc':
                $state.go('tab.home').then(function () {
                  $state.go('tab.home-LYDTDetail', {
                    params: {
                      id: info.bussiness_id,
                      content: info.content
                    }
                  });
                });
                break;
              case 'lydt':
                $state.go('tab.home').then(function () {
                  $state.go('tab.home-LYDTDetail', {
                    params: {
                      id: info.bussiness_id,
                      content: info.content
                    }
                  });
                });
                break;
              case 'fmkc':
                $state.go('tab.home').then(function () {
                  $state.go('tab.home-FMKT-HDXQPage', {
                    params: {
                      id: info.bussiness_id,
                      content: info.content
                    }
                  });
                });
                break;
              case 'hd':
                $state.go('tab.' + currentTab).then(function () {
                  $state.go('tab.' + currentTab + '-HDXQPage', {
                    params: {
                      id: info.bussiness_id,
                      content: info.content
                    }
                  });
                });
                break;
              default:
                if (info.url) {
                  $state.go(info.url, {
                    params: info.params
                  });
                }
            }
            break;
          case 'kqtz':
            if (currentTab === 'activitiesAndServices') {
              $state.go('tab.activitiesAndServices').then(function () {
                $state.go('tab.activitiesAndServices-HDQDPage');
              });
            } else {
              $state.go('tab.' + currentTab).then(function () {
                $state.go('tab.' + currentTab + '-QDQJPage');
              });
            }
            break;
          case "kq":
            $state.go('tab.personal').then(function () {
              $state.go('tab.personal-kqjl').then(function () {
                $ionicHistory.removeBackView();
              })
            });
            break;
          case "sksjxg":
            break;
          case "bk":
            $state.go('tab.courses').then(function () {
              var item = JSON.parse(info.push_map);
              $state.go('tab.courses-WDYDDetail', {
                params: {
                  id: item.campId,
                  camp_name: item.campName
                }
              });
            });
            break;
          case "sk":
            break;
          case "wj":
            getQuestionnaire.open(info);
            break;
          case "lyhf":
            var item = info;
            $state.go('tab.' + currentTab).then(function () {
              $state.go('tab.' + currentTab + '-onlineMessage', {
                params: {
                  businessDesc: item.businessDesc,
                  course_lesson_num: item.lessonNum,
                  id: item.bussiness_id,
                  camp_id: item.campId,
                  type_code: item.businessType,
                  lesson_id: item.lesson_id
                }
              });
            });
            break;
          case "xzhd":
            $state.go('tab.' + currentTab + '-xzhdDetailPage', {
              params: {
                id: info.bussiness_id
              }
            });
            break;
          default:
            if (info.url) {
              $state.go(info.url, {
                params: info.params
              });
            }
        }
      };
      $window.plugins.jPushPlugin.init();
      $window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
      $window.plugins.jPushPlugin.resumePush();
      $window.plugins.jPushPlugin.getUserNotificationSettings(function (res) {
        if (res === 0) {
          alert("请去设置打开应用通知权限!")
        }
      });
      document.addEventListener("jpush.openNotification", function (event) {
        var extras;
        if (ionic.Platform.isAndroid()) {
          extras = event.extras;
        } else {
          extras = event.extras;
        }
        onJPush(extras, $ionicHistory.currentView().url.split('/')[2] || "home")
      }, false);
      document.addEventListener("jpush.receiveNotification", function (event) {
        var extras;
        if (ionic.Platform.isAndroid()) {
          extras = event.extras;
        } else {
          extras = event.extras;
        }
        if (extras.type === "tw") {
          // $rootScope.badge.tw[extras.message_category] = ++$rootScope.badge.tw[extras.message_category];
        } else {
          $rootScope.setMessage();
          // $rootScope.badge[extras.type] = ++$rootScope.badge[extras.type];
        }
        /*        countBadge('home');
                countBadge('courses', ['hd']);
                countBadge('activitiesAndServices');*/
        $rootScope.initUnRead();
      }, false)
    });
  })
  /*  .constant('', function () {

    })*/
  .value('searchPlaceholder', '请输入想要查询的活动名称')
  .config(['$resourceProvider', function ($resourceProvider) {
    $resourceProvider.defaults.stripTrailingSlashes = false;
  }])
  .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $httpProvider) {

    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('standard');

    //post发送失败修复代码
    $httpProvider.defaults.transformRequest = function (obj) {
      var str = [];
      for (var p in obj) {
        str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
      }
      return str.join("&");
    };
    $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';

    //同意配置不同平台统一样式
    $ionicConfigProvider.scrolling.jsScrolling(true);
    $ionicConfigProvider.backButton.text('').icon('ion-chevron-left').previousTitleText(false);
    $ionicConfigProvider.navBar.alignTitle('center');

    //禁止右滑
    $ionicConfigProvider.views.swipeBackEnabled(false);
    // Ionic uses AngularUI Router which uses the concept of states
    // Learn more here: https://github.com/angular-ui/ui-router
    // Set up the various states which the app can be in.
    // Each state's controller can be found in controllers.js
    $stateProvider
    // setup an abstract state for the tabs directive
      .state('login', {
        cache: false,
        url: '/login',
        templateUrl: 'templates/login.html',
        controller: 'LoginCtrl'
      })
      .state('tab', {
        cache: false,
        url: '/tab',
        abstract: true,
        templateUrl: 'templates/tabs.html'
      })

      // Each tab has its own nav history stack:

      .state('tab.home', {
        url: '/home',
        cache: false,
        views: {
          'tab-home': {
            templateUrl: 'templates/home/tab-home.html',
            controller: 'HomeCtrl'
          }
        }
      })

      .state('tab.courses', {
        url: '/courses',
        cache: false,
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/tab-courses.html',
            controller: 'CoursesCtrl'
          }
        }
      })

      .state('tab.activitiesAndServices', {
        url: '/activitiesAndServices',
        cache: false,
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/activitiesAndServices/tab-activitiesAndServices.html',
            controller: 'ActivitiesAndServicesCtrl'
          }
        }
      })

      .state('tab.personal', {
        url: '/personal',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/tab-personal.html',
            controller: 'PersonalCtrl'
          }
        },
        cache: false
      })
      .state('intro', {
        cache: false,
        url: '/intro',
        templateUrl: 'templates/intro.html',
        controller: 'introCtrl'
      })
      .state('tab.home-searchPage', {
        url: '/home/search',
        params: {
          params: null
        },
        cache: false,
        views: {
          'tab-home': {
            templateUrl: 'templates/home/searchPage.html',
            controller: 'SearchPageCtrl'
          }
        }
      })
      .state('tab.courses-searchPage', {
        url: '/courses/search',
        params: {
          params: null
        },
        cache: false,
        views: {
          'tab-courses': {
            templateUrl: 'templates/home/searchPage.html',
            controller: 'SearchPageCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-searchPage', {
        url: '/activitiesAndServices/search',
        params: {
          params: null
        },
        cache: false,
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/home/searchPage.html',
            controller: 'SearchPageCtrl'
          }
        }
      })

      .state('tab.home-ZDKCPage', {
        cache: false,
        url: '/home/zdkc',
        views: {
          'tab-home': {
            templateUrl: 'templates/course/course-zdkc.html',
            controller: 'ZDKCPageCtrl'
          }
        }
      })
      .state('tab.courses-ZDKCPage', {
        cache: false,
        url: '/courses/zdkc',
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/course-zdkc.html',
            controller: 'ZDKCPageCtrl'
          }
        }
      })
      .state('tab.home-BKZXPage', {
        cache: false,
        url: '/home/bkzx',
        views: {
          'tab-home': {
            templateUrl: 'templates/course/course-bkzx.html',
            controller: 'BKZXPageCtrl'
          }
        }
      })
      .state('tab.courses-BKZXPage', {
        cache: false,
        url: '/courses/bkzx',
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/course-bkzx.html',
            controller: 'BKZXPageCtrl'
          }
        }
      })
      .state('tab.home-QDQJPage', {
        cache: false,
        url: '/home/qdqj',
        views: {
          'tab-home': {
            templateUrl: 'templates/course/course-qdqj.html',
            controller: 'QDQJPageCtrl'
          }
        }
      })
      .state('tab.courses-QDQJPage', {
        cache: false,
        url: '/courses/qdqj',
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/course-qdqj.html',
            controller: 'QDQJPageCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-QDQJPage', {
        cache: false,
        url: '/activitiesAndServices/qdqj',
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/course/course-qdqj.html',
            controller: 'QDQJPageCtrl'
          }
        }
      })
      .state('tab.home-KCZZDPage', {
        cache: false,
        url: '/home/kczzd',
        views: {
          'tab-home': {
            templateUrl: 'templates/course/course-kczzd.html',
            controller: 'KCZZDPageCtrl'
          }
        }
      })
      .state('tab.courses-KCZZDPage', {
        cache: false,
        url: '/courses/kczzd',
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/course-kczzd.html',
            controller: 'KCZZDPageCtrl'
          }
        }
      })
      .state('tab.home-HDTJPage', {
        cache: false,
        url: '/home/hdtj',
        views: {
          'tab-home': {
            templateUrl: 'templates/activitiesAndServices/activities-hdtj.html',
            controller: 'HDTJPageCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-HDTJPage', {
        cache: false,
        url: '/activitiesAndServices/hdtj',
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/activitiesAndServices/activities-hdtj.html',
            controller: 'HDTJPageCtrl'
          }
        }
      })
      .state('tab.home-homework', {
        cache: false,
        url: '/home/homework',
        params: {
          params: null
        },
        views: {
          'tab-home': {
            templateUrl: 'templates/course/course-homework.html',
            controller: 'HomeworkPageCtrl'
          }
        }
      })
      .state('tab.courses-homework', {
        cache: false,
        url: '/courses/homework',
        params: {
          params: null
        },
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/course-homework.html',
            controller: 'HomeworkPageCtrl'
          }
        }
      })
      .state('tab.courses-EQhomework', {
        cache: false,
        url: '/courses/EQ/homework',
        params: {
          params: null
        },
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/EQ-homework.html',
            controller: 'EQHomeworkPageCtrl'
          }
        }
      })
      .state('tab.home-ysklist', {
        cache: false,
        url: '/home/yskList',
        params: {
          params: null
        },
        views: {
          'tab-home': {
            templateUrl: 'templates/course/course-ysklist.html',
            controller: 'YSKListCtrl'
          }
        }
      })
      .state('tab.courses-ysklist', {
        cache: false,
        url: '/courses/yskList',
        params: {
          params: null
        },
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/course-ysklist.html',
            controller: 'YSKListCtrl'
          }
        }
      })
      .state('tab.courses-EQysklist', {
        cache: false,
        url: '/courses/EQ/yskList',
        params: {
          params: null
        },
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/EQ-ysklist.html',
            controller: 'EQYSKListCtrl'
          }
        }
      })
      .state('tab.home-FMKT-HDXQPage', {
        url: '/home/fmkt/hdxq',
        params: {
          params: null
        },
        cache: false,
        views: {
          'tab-home': {
            templateUrl: 'templates/home/fmkt-hdxq.html',
            controller: 'FMKTXQPageCtrl'
          }
        }
      })
      .state('tab.home-HDXQPage', {
        url: '/home/hdtj/hdxq',
        params: {
          params: null
        },
        cache: false,
        views: {
          'tab-home': {
            templateUrl: 'templates/activitiesAndServices/hdtj-hdxq.html',
            controller: 'HDXQPageCtrl'
          }
        }
      })
      .state('tab.courses-HDXQPage', {
        url: '/courses/hdtj/hdxq',
        params: {
          params: null
        },
        cache: false,
        views: {
          'tab-courses': {
            templateUrl: 'templates/activitiesAndServices/hdtj-hdxq.html',
            controller: 'HDXQPageCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-HDXQPage', {
        url: '/activitiesAndServices/hdtj/hdxq',
        params: {
          params: null
        },
        cache: false,
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/activitiesAndServices/hdtj-hdxq.html',
            controller: 'HDXQPageCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-CJHDPage', {
        url: '/activitiesAndServices/cjhd',
        params: {
          params: null
        },
        cache: false,
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/activitiesAndServices/activities-cjhd.html',
            controller: 'CJHDPageCtrl'
          }
        }
      })
      .state('tab.home-HZDTPage', {
        cache: false,
        url: '/home/hzdt',
        views: {
          'tab-home': {
            templateUrl: 'templates/home/home-hzdt.html',
            controller: 'HZDTPageCtrl'
          }
        }
      })
      .state('tab.home-GNListPage', {
        cache: false,
        url: '/home/hzdt/GN/list',
        views: {
          'tab-home': {
            templateUrl: 'templates/home/hzdt-gnList.html',
            controller: 'GNListCtrl'
          }
        }
      })
      .state('tab.home-GZListPage', {
        cache: false,
        url: '/home/hzdt/GZ/list',
        views: {
          'tab-home': {
            templateUrl: 'templates/home/hzdt-gzList.html',
            controller: 'GZListCtrl'
          }
        }
      })
      .state('tab.home-XJListPage', {
        cache: false,
        url: '/home/hzdt/XJ/list',
        views: {
          'tab-home': {
            templateUrl: 'templates/home/hzdt-xjList.html',
            controller: 'XJListCtrl'
          }
        }
      })
      .state('tab.home-GNDetailPage', {
        cache: false,
        url: '/home/hzdt/GN/detail',
        params: {
          params: null
        },
        views: {
          'tab-home': {
            templateUrl: 'templates/home/gn-detail.html',
            controller: 'GNDetailCtrl'
          }
        }
      })
      .state('tab.home-GZDetailPage', {
        cache: false,
        url: '/home/hzdt/GZ/detail',
        params: {
          params: null
        },
        views: {
          'tab-home': {
            templateUrl: 'templates/home/gz-detail.html',
            controller: 'GZDetailCtrl'
          }
        }
      })
      .state('tab.home-XJDetailPage', {
        cache: false,
        url: '/home/hzdt/XJ/detail',
        params: {
          params: null
        },
        views: {
          'tab-home': {
            templateUrl: 'templates/home/xj-detail.html',
            controller: 'XJDetailCtrl'
          }
        }
      })
      .state('tab.home-LYDTPage', {
        cache: false,
        url: '/home/lydt',
        views: {
          'tab-home': {
            templateUrl: 'templates/home/home-lydt.html',
            controller: 'LYDTListCtrl'
          }
        }
      })
      .state('tab.home-LYDTDetail', {
        cache: false,
        url: '/home/lydt.detail',
        params: {
          params: null
        },
        views: {
          'tab-home': {
            templateUrl: 'templates/home/lydt-detail.html',
            controller: 'LYDTDetailCtrl'
          }
        }
      })
      .state('tab.home-fmkt', {
        cache: false,
        url: '/home/fmkt',
        views: {
          'tab-home': {
            templateUrl: 'templates/home/home-fmkt.html',
            controller: 'FMKTPageCtrl'
          }
        }
      })
      .state('tab.courses-eq', {
        cache: false,
        url: '/courses/eq',
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/course-eq.html',
            controller: 'EQPageCtrl'
          }
        }
      })
      .state('tab.courses-YXHList', {
        cache: false,
        url: '/courses/YXHList',
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/course-yxh.html',
            controller: 'ConsumeLessonsCtrl'
          }
        }
      })
      //hello
      .state('tab.courses-WDYDList', {
        cache: false,
        url: '/courses/wdydList',
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/course-wdyd.html',
            controller: 'WDYDListCtrl'
          }
        }
      })
      .state('tab.courses-WDYDDetail', {
        cache: false,
        params: {
          params: null
        },
        url: '/courses/WDYDDetail',

        views: {
          'tab-courses': {
            templateUrl: 'templates/course/wdyd-detail.html',
            controller: 'WDYDDetailCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-WCJActivitiesList', {
        cache: false,
        url: '/activitiesAndServices/WDYDDetail',
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/activitiesAndServices/activities-wcjhd.html',
            controller: 'WCJActivitiesListCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-YCJActivitiesList', {
        cache: false,
        url: '/activitiesAndServices/YDYDDetail',
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/activitiesAndServices/activities-ycjhd.html',
            controller: 'YCJActivitiesListCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-HDQDPage', {
        cache: false,
        url: '/activitiesAndServices/HDQDPage',
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/activitiesAndServices/activities-hdqd.html',
            controller: 'QDQJPageCtrl'
          }
        }
      })
      .state('tab.personal-settings', {
        cache: false,
        url: '/personal/settings',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/personal-settings.html',
            controller: 'SettingsCtrl'
          }
        }
      })
      .state('tab.personal-aboutUs', {
        cache: false,
        url: '/personal/settings/aboutUs',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/settings-aboutUs.html'
          }
        }
      })
      .state('tab.personal-infoPage', {
        cache: false,
        url: '/personal/infoPage',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/personal-info.html',
            controller: 'InfoPageCtrl'
          }
        }
      })
      .state('tab.personal-changePassword', {
        cache: false,
        url: '/personal/changePassword',
        params: {
          params: null
        },
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/changePassword.html',
            controller: 'changePassword'
          }
        }
      })
      .state('tab.personal-myOrder', {
        cache: false,
        url: '/personal/myOrder',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/personal-myOrder.html',
            controller: 'MyOrderPageCtrl'
          }
        }
      })
      .state('tab.home-kqjl', {
        cache: false,
        url: '/home/kqjl',
        views: {
          'tab-home': {
            templateUrl: 'templates/personal/personal-kqjl.html',
            controller: 'AttendanceRecordCtrl'
          }
        }
      })
      .state('tab.courses-kqjl', {
        cache: false,
        url: '/courses/kqjl',
        views: {
          'tab-courses': {
            templateUrl: 'templates/personal/personal-kqjl.html',
            controller: 'AttendanceRecordCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-kqjl', {
        cache: false,
        url: '/activitiesAndServices/kqjl',
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/personal/personal-kqjl.html',
            controller: 'AttendanceRecordCtrl'
          }
        }
      })
      .state('tab.personal-kqjl', {
        cache: false,
        url: '/personal/kqjl',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/personal-kqjl.html',
            controller: 'AttendanceRecordCtrl'
          }
        }
      })
      .state('tab.personal-qscs', {
        cache: false,
        url: '/personal/qscs',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/personal-qscs.html',
            controller: 'EQTestListPageCtrl'
          }
        }
      })
      .state('tab.personal-qscsDetail', {
        cache: false,
        url: '/personal/qscs/detail',
        params: {
          params: null
        },
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/qscs-detail.html',
            controller: 'EQTestDetailPageCtrl'
          }
        }
      })
      .state('tab.personal-wjdcList', {
        cache: false,
        url: '/personal/wjdc',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/personal-wjdc.html',
            controller: 'WJDCListPageCtrl'
          }
        }
      })
      .state('tab.home-onlineMessage', {
        cache: false,
        url: '/home/onlineMessage',
        params: {
          params: null
        },
        views: {
          'tab-home': {
            templateUrl: 'templates/home/hzdt-onlineMessage.html',
            controller: 'onlineMessageCtrl'
          }
        }
      })
      .state('tab.courses-onlineMessage', {
        cache: false,
        url: '/courses/onlineMessage',
        params: {
          params: null
        },
        views: {
          'tab-courses': {
            templateUrl: 'templates/home/hzdt-onlineMessage.html',
            controller: 'onlineMessageCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-onlineMessage', {
        cache: false,
        url: '/activitiesAndServices/onlineMessage',
        params: {
          params: null
        },
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/home/hzdt-onlineMessage.html',
            controller: 'onlineMessageCtrl'
          }
        }
      })
      .state('tab.personal-studentInfo', {
        cache: false,
        url: '/personal/studentInfo',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/personal-studentInfo.html',
            controller: 'StudentInfoPageCtrl'
          }
        }
      })
      .state('tab.courses-wybk', {
        cache: false,
        url: '/courses/wybk',
        views: {
          'tab-courses': {
            templateUrl: 'templates/course/course-wybk.html',
            controller: 'WYBKListCtrl'
          }
        }
      })
      .state('tab.home-msgList', {
        cache: false,
        url: '/home/msgList',
        views: {
          'tab-home': {
            templateUrl: 'templates/home/hzdt-msgList.html',
            controller: 'msgListCtrl'
          }
        }
      })
      .state('tab.home-test', {
        cache: false,
        url: '/home/msgList',
        views: {
          'tab-home': {
            templateUrl: 'templates/test.html',
            controller: 'msgListCtrl'
          }
        }
      })
      .state('tab.home-payResult', {
        cache: false,
        url: '/home/payResult',
        params: {
          params: null
        },
        views: {
          'tab-home': {
            templateUrl: 'templates/payResult.html',
            controller: 'payResultCtrl'
          }
        }
      })
      .state('tab.courses-payResult', {
        cache: false,
        url: '/courses/payResult',
        params: {
          params: null
        },
        views: {
          'tab-courses': {
            templateUrl: 'templates/payResult.html',
            controller: 'payResultCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-payResult', {
        cache: false,
        url: '/activitiesAndServices/payResult',
        params: {
          params: null
        },
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/payResult.html',
            controller: 'payResultCtrl'
          }
        }
      })
      .state('tab.home-xzhdDetailPage', {
        cache: false,
        url: '/home/xzhdDetail',
        params: {
          params: null
        },
        views: {
          'tab-home': {
            templateUrl: 'templates/xzhdxq.html',
            controller: 'xzhdxqCtrl'
          }
        }
      })
      .state('tab.courses-xzhdDetailPage', {
        cache: false,
        url: '/courses/xzhdDetail',
        params: {
          params: null
        },
        views: {
          'tab-courses': {
            templateUrl: 'templates/xzhdxq.html',
            controller: 'xzhdxqCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-xzhdDetailPage', {
        cache: false,
        url: '/activitiesAndServices/xzhdDetail',
        params: {
          params: null
        },
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/xzhdxq.html',
            controller: 'xzhdxqCtrl'
          }
        }
      })
      .state('tab.personal-xzhdDetailPage', {
        cache: false,
        url: '/personal/xzhdDetail',
        params: {
          params: null
        },
        views: {
          'tab-personal': {
            templateUrl: 'templates/xzhdxq.html',
            controller: 'xzhdxqCtrl'
          }
        }
      })
      .state('tab.personal-classSchedule', {
        cache: false,
        url: '/personal/classSchedule',
        views: {
          'tab-personal': {
            templateUrl: 'templates/personal/personal-classSchedule.html',
            controller: 'classScheduleCtrl'
          }
        }
      })

      .state('tab.home-messageList', {
        cache: false,
        url: '/home/messageList',
        params: {
          params: null
        },
        views: {
          'tab-home': {
            templateUrl: 'templates/messageList.html',
            controller: 'messageListCtrl'
          }
        }
      })
      .state('tab.courses-messageList', {
        cache: false,
        url: '/courses/messageList',
        params: {
          params: null
        },
        views: {
          'tab-courses': {
            templateUrl: 'templates/messageList.html',
            controller: 'messageListCtrl'
          }
        }
      })
      .state('tab.activitiesAndServices-messageList', {
        cache: false,
        url: '/activitiesAndServices/messageList',
        params: {
          params: null
        },
        views: {
          'tab-activitiesAndServices': {
            templateUrl: 'templates/messageList.html',
            controller: 'messageListCtrl'
          }
        }
      })


    ;

    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/intro');
  });
