var appCtrl = angular.module('starter.controllers', [])
  .controller('LoginCtrl', function ($scope, Login, $ionicLoading, $rootScope, Storage, $ionicPopup, User, $ionicHistory, $state, $ionicModal, getStudentInfo) {
    $scope.height = "min-height:" + window.screen.height + "px";
    $rootScope.pageCode = "dl";
    $scope.user = Storage.get('rememberPassword');
    if ($scope.user) {
      $scope.rememberPassword = true;
    }

    function goLogin(user) {
      if (user === undefined || user.username === undefined) {
        $rootScope.showToastMessage('请填写用户名!');
      } else if (user.password === undefined) {
        $rootScope.showToastMessage('请填写密码!');
      } else {
        $ionicLoading.show({
          templateUrl: "templates/loading.html"
        });
        Login.validUser(user).then(function (res) {
          if ($scope.rememberPassword && res) {
            Storage.set('rememberPassword', user);
          } else if (!$scope.rememberPassword) {
            Storage.remove('rememberPassword');
          }
          $ionicLoading.hide();
          if (user.password === "111111") {
            $ionicPopup.confirm({
              template: '初始密码需要修改!',
              cancelText: '退出登入',
              cancelType: 'assertive-important',
              okText: '去修改',
              okType: 'button-positive'
            }).then(function (res) {
              if (res) {
                $state.go('tab.personal').then(function () {
                  $ionicHistory.nextViewOptions({
                    historyRoot: true
                  });
                  $state.go('tab.personal-changePassword', {
                    params: {
                      id: User.getCurrentUserId()
                    }
                  }).then(function () {
                    User.logout();
                  });
                });

              } else {
                User.logout();
                $ionicHistory.nextViewOptions({
                  historyRoot: true
                });
                $state.go('login');
              }
            });
          } else {
            getStudentInfo.query().$promise.then(function (res) {
              $rootScope.changeInfo = {};
              $rootScope.changeInfo.studentInfo = res;
              $rootScope.changeInfo.studentInfo = $rootScope.changeInfo.studentInfo.map(function (item) {
                item.brithday = new Date(item.brithday);
                return item;
              });

              function validInfo() {
                for (var i = 0; i < $rootScope.changeInfo.studentInfo.length; i++) {
                  var info = $rootScope.changeInfo.studentInfo[i];
                  if (!(info.name && info.brithday && info.mobile)) {
                    return false
                  }
                }
              }

              if (validInfo() === false) {
                $ionicPopup.confirm({
                  template: '初始信息需要修改!',
                  cancelText: '退出登录',
                  cancelType: 'assertive-important',
                  okText: '去修改',
                  okType: 'button-positive'
                }).then(function (res) {
                  if (res) {
                    $ionicModal.fromTemplateUrl('templates/changeInfo.html', {
                      scope: $rootScope,
                      animation: 'slide-in-up'
                    }).then(function (modal) {
                      $rootScope.changeInfo.modal = modal;
                      $rootScope.changeInfo.modal.show();
                      $rootScope.changeInfo.closeModal = function () {
                        $rootScope.changeInfo.modal.hide();
                        User.logout();
                        $ionicHistory.nextViewOptions({
                          historyRoot: true
                        });
                        $state.go('login');
                      };
                      $rootScope.changeInfo.save = function () {
                        if (validInfo() === false) {
                          $ionicPopup.alert({
                            template: '带*必填!'
                          })
                        } else {
                          var edit = function (info) {
                            var thePromise = getStudentInfo.save(info).$promise;
                            thePromise.catch(function (err) {
                              $rootScope.showToastMessage(info.name + err.msgDesc)
                            });
                            return thePromise;
                          };
                          Promise.all($rootScope.changeInfo.studentInfo.map(function (info) {
                            return edit(info);
                          })).then(function () {
                            $rootScope.changeInfo.modal.hide();
                            $rootScope.showToastMessage('保存成功');
                          });
                        }
                      };
                    });
                  } else {
                    User.logout();
                    $ionicHistory.nextViewOptions({
                      historyRoot: true
                    });
                    $state.go('login');
                  }
                })
              }
            }).catch(function () {
              $rootScope.showNetworkAnomalyToastMessage();
            }).finally(function () {
              $rootScope.changeInfo.loading = false;
            });

          }
        }).catch(function (err) {
          $ionicLoading.hide();
        })
      }
    }

    $scope.login = function (user) {
      goLogin(user);
    }
  })
  .controller('introCtrl', function ($rootScope, $interval, $scope, $ionicHistory, $state, $cordovaSplashscreen, getAppAdvertisement) {
    $rootScope.pageCode = "gg";
    $scope.count = 3;

    function minus() {
      $scope.count--;
      if (!$scope.count) {
        $scope.startApp();
      }
    }

    var interval;
    $scope.startApp = function () {
      $ionicHistory.nextViewOptions({
        disableBack: true
      });
      $state.go('tab.home').then(function () {
      }).finally(function () {
        $interval.cancel(interval);
      });
    };
    document.getElementById('img').onload = function () {
      interval = $interval(minus, 1000);
      $cordovaSplashscreen.hide();
    };

    getAppAdvertisement.get().$promise.then(function (res) {
      if (res.atts) {
        $rootScope.adId = res.id;
        $scope.atts = JSON.parse(res.atts)[0];
        $scope.open = function () {
          window.open(res.link_address, '_blank', 'location=yes');
        };
      } else {
        $scope.startApp()
      }
    }).catch(function () {
      /* $state.go('tab.home').then(function () {
         $cordovaSplashscreen.hide();
         $ionicHistory.removeBackView();
       });*/
      $cordovaSplashscreen.hide();
      $scope.startApp();
      $rootScope.showNetworkAnomalyToastMessage();
    });
  })
  .controller('payResultCtrl', function ($rootScope, $scope, $stateParams) {
    $rootScope.pageCode = "zfjg";
    if ($stateParams.params.resultStatus == '9000') {
      $scope.res = "success";
    } else if ($stateParams.params.resultStatus == '4000' || $stateParams.params.resultStatus == '6001' || $stateParams.params.resultStatus == '6002') {
      $scope.res = "err";
    } else if ($stateParams.params.resultStatus != '8000' && $stateParams.params.resultStatus != '8000') {
      $scope.res = "err";
    }
  })
  .controller('xzhdxqCtrl', function ($rootScope, $scope, $stateParams, getNewActivityInfo, popup, getOrder, $ionicPopup) {

    $rootScope.pageCode = "zxhdxq";
    $scope.loading = true;
    $scope.pay = function (info) {
      popup.activityAgreementPopup($scope).then(function (res) {
        if (res) {
          popup.studentsPopup($scope).then(function (res) {
            if (info.activityInfo.actPrice == 0) {
              getOrder.activityOrder(res, info.activityInfo).$promise.then(function (res) {
                $ionicPopup.alert({
                  template: res.msgDesc,
                  okText: '关闭'
                })
              }).catch(function () {
                $rootScope.showNetworkAnomalyToastMessage();
              })
            } else {
              $scope.payName = "活动";
              popup.selectPayMethod($scope, res, info.activityInfo).then(function (fnc) {
                if (fnc) fnc("activityOrder");
              });
            }
          })
        }
      })
    };

    getNewActivityInfo.get($stateParams.params.id).$promise.then(function (res) {
      $scope.hdInfo = res;
      $rootScope.toPushtitle = res.activityInfo.actName;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    })
  })

  .controller('messageListCtrl', function ($rootScope, $scope, $stateParams, getGatherPushMessage) {
    $rootScope.pageCode = "xxjhlb";
    $scope.playgroundInfo = [];
    $scope.newPlaygroundInfo = [];
    var type = $stateParams.params.type;
    $scope.doRefresh = function () {
      getGatherPushMessage.queryGatherList(type).$promise.then(function (res) {
        $scope.loading = true;
        $scope.newPlaygroundInfo = res;
        $scope.playgroundInfo = res;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
        $scope.$broadcast('scroll.refreshComplete')
      })
    }

    $scope.doRefresh();
    //上拉加载数据
    $scope.loadMore = function () {
      getGatherPushMessage.queryGatherList(type, $scope.playgroundInfo[$scope.playgroundInfo.length - 1].id).$promise.then(function (res) {
        $scope.newPlaygroundInfo = res;
        $scope.playgroundInfo = $scope.playgroundInfo.concat($scope.newPlaygroundInfo);
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.$broadcast('scroll.infiniteScrollComplete')
      });
    };
  })

;

