appCtrl

  .controller('CoursesCtrl', function ($rootScope, $scope, GetInfo, searchPlaceholder, $state, $interval, User) {
    $rootScope.clearBadge();
    $rootScope.pageCode = "kc";
    $scope.playgroundInfo = [];
    $scope.newPlaygroundInfo = [];
    //搜索插件
    $scope.placeholder = searchPlaceholder;
    $scope.onSearch = function (search) {
      $state.go('tab.courses-searchPage', {
        params: ''
      });
      if (event.which === 13) {
        $state.go('tab.courses-searchPage', {
          params: search
        })
      }
    };
    //下拉刷新
    $scope.doRefresh = function () {
      $rootScope.clearBadge(['hd']);
      GetInfo.query("kc").$promise.then(function (res) {
        $scope.playgroundInfo = res;
        $scope.snapshot = JSON.parse(JSON.stringify(res));

        //时间实效性过滤
        function filterTime() {
          $scope.playgroundInfo.forEach(function (item, index) {
            item.push_date = moment($scope.snapshot[index].push_date).from(moment());
          })
        }

        //结束之前的轮询建立新的
        if ($rootScope.twTimeline) {
          $interval.cancel($rootScope.twTimeline);
        }
        filterTime();
        $rootScope.twTimeline = $interval(function () {
          filterTime();
        }, 60000);

      }).catch(function () {
        if (User.getCurrentUserId()) {
          $rootScope.showNetworkAnomalyToastMessage();
        }
      }).finally(function () {
        $scope.$broadcast('scroll.refreshComplete')
      });
    };
    //上拉加载数据
    $scope.loadMore = function () {
      GetInfo.query("kc", $scope.playgroundInfo[$scope.playgroundInfo.length - 1].id).$promise.then(function (res) {
        $scope.newPlaygroundInfo = res;
        $scope.playgroundInfo = $scope.playgroundInfo.concat($scope.newPlaygroundInfo);
        $scope.snapshot = JSON.parse(JSON.stringify([$scope.snapshot].concat(res)));

        //时间实效性过滤
        function filterTime() {
          $scope.playgroundInfo.forEach(function (item, index) {
            item.push_date = moment($scope.snapshot[index].push_date).from(moment());
          })
        }

        //结束之前的轮询建立新的
        if ($rootScope.twTimeline) {
          $interval.cancel($rootScope.twTimeline);
        }
        filterTime();
        $rootScope.twTimeline = $interval(function () {
          filterTime();
        }, 60000);

      }).catch(function () {
        if (User.getCurrentUserId()) {
          $rootScope.showNetworkAnomalyToastMessage();
        }
      }).finally(function () {
        $scope.$broadcast('scroll.infiniteScrollComplete')
      });
    };


    $scope.doRefresh();

  })
  //在读课程
  .controller('ZDKCPageCtrl', function ($scope, getZDKCInfo, $rootScope) {
    $rootScope.pageCode = "zdkc";
    $scope.loading = true;
    getZDKCInfo.query().$promise.then(function (res) {
      $scope.ZDKCInfo = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });

  })
  //补课中心
  .controller('BKZXPageCtrl', function ($scope, getBKZXInfo, popup, $rootScope) {
    $rootScope.pageCode = "bkzx";


    function init() {
      $scope.loading = true;

      getBKZXInfo.query().$promise.then(function (res) {
        $scope.BKZXInfo = res;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
      });
    }

    init();
    var confirm = {
      message: "请确认是否补课",
      closeButtonText: "取消",
      confirmButtonText: "确定"
    };
    $scope.makeUp = function (info) {
      popup.popupConfirm(confirm).then(function (res) {
        if (res) {
          $scope.loading = true;

          getBKZXInfo.makeUp(info.studentId, info.lesson_id, info.bkLessonId).$promise.then(function (res) {
            popup.popupAlert({template: res.msgDesc})
            if (res.msgCode) {
              $scope.BKZXInfo.splice($scope.BKZXInfo.indexOf(info), 1);
            } else {
              init();
            }
          }).catch(function () {
            $rootScope.showNetworkAnomalyToastMessage();
          }).finally(function () {
            $scope.loading = false;
          });
        }
      })

    };
  })
  //签到请假
  .controller('QDQJPageCtrl', function ($scope, getQDQJInfo, popup, $rootScope, $ionicHistory) {
    var type;
    var currentView = $ionicHistory.currentView().url.split('/')[2];
    if (currentView === "home") {
      type = "all";
    } else if (currentView === "courses") {
      type = "kc";
    } else if (currentView === "activitiesAndServices") {
      type = "hd"
    }
    $rootScope.pageCode = type + "qdqj";

    function init() {
      $scope.loading = true;

      getQDQJInfo.query(type).$promise.then(function (res) {
        $scope.QDQJInfo = res
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
      });
    }

    init();

    $scope.markInfo = {
      title: "是否签到",
      message: "请确认是否签到",
      closeButtonText: "取消",
      confirmButtonText: "确定"
    };
    $scope.leaveInfo = {
      title: "请假理由",
      closeButtonText: "取消",
      confirmButtonText: "确定",
      placeholder: "请填写详细的请假理由"
    };
    $scope.popupDetail = function (item) {
      if (event.toElement.tagName !== 'BUTTON') {
        popup.popupAlert({
          title: item.course_name,
          template: item.attendancetype ? (item.attendancetype === "zs" ? "考勤日期:" + item.attendancedate : "请假理由:" + item.attendancedesc) : "暂未操作",
          confirmButtonText: "关闭"
        })
      }
    };
    $scope.onMark = function (item) {
      popup.popupConfirm($scope.markInfo).then(function (res) {
        if (res) {
          $scope.loading = true;
          getQDQJInfo.saveAttendance(item, "zs").$promise.then(function (res) {
            popup.popupAlert({
              template: res.msg,
              confirmButtonText: "关闭"
            });
            if (res.success) {
              $scope.QDQJInfo[$scope.QDQJInfo.indexOf(item)] = res;
            }
          }).catch(function () {
            $rootScope.showNetworkAnomalyToastMessage();
          }).finally(function () {
            $scope.loading = false;
          });
        }
      })
    };
    $scope.onLeave = function (item) {
      popup.popupPrompt($scope.leaveInfo).then(function (res) {
        if (res) {
          item._attendanceDesc = res;
          $scope.loading = true;

          getQDQJInfo.saveAttendance(item, "qj").$promise.then(function (res) {
            popup.popupAlert({
              template: res.msg,
              confirmButtonText: "关闭"
            });
            if (res.success) {
              $scope.QDQJInfo[$scope.QDQJInfo.indexOf(item)] = res;
            }
          }).catch(function () {
            $rootScope.showNetworkAnomalyToastMessage();
          }).finally(function () {
            $scope.loading = false;
          });
        } else {
          if (res !== undefined) {
            popup.popupAlert({
              template: '请假理由不能为空',
              confirmButtonText: "关闭"
            });
          }
        }
      })
    }
  })
  //课程早知道
  .controller('KCZZDPageCtrl', function ($scope, $ionicHistory, $rootScope) {
    $rootScope.pageCode = "kczzdlb";
    //没有好的方法,只能这么干
    $scope.currentView = $ionicHistory.currentView().url.split('/')[2];

  })
  .controller('DSKPageCtrl', function ($scope, getKCZZDInfo, $rootScope) {
    $scope.loading = true;
    getKCZZDInfo.query('dsk').$promise.then(function (res) {
      $scope.DSKList = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
      setTimeout(function () {
        $scope.loading = true
      }, 1000)
    });
  })
  .controller('YSKTypeCtrl', function ($scope, getKCZZDInfo, $rootScope) {
    $scope.loading = true;

    getKCZZDInfo.query('ysk').$promise.then(function (res) {
      $scope.YSKType = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('YSKListCtrl', function ($scope, $stateParams, $ionicHistory, getKCZZDInfo, $rootScope) {
    $scope.loading = true;

    $rootScope.pageCode = "ysklb";
    $scope.currentView = $ionicHistory.currentView().url.split('/')[2];
    getKCZZDInfo.queryYSK($stateParams.params).$promise.then(function (res) {
      $rootScope.toPushtitle = res.camp_name + res.course_name + res.course_lesson_num;

      $rootScope.toPushtitle = $stateParams.params.camp_name;

      $scope.YSKList = res
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('SZZYPageCtrl', function ($scope, getKCZZDInfo, $rootScope) {
    $scope.loading = true;

    getKCZZDInfo.query('sz').$promise.then(function (res) {
      $scope.SZZYInfo = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  //家庭eq策略
  .controller('EQPageCtrl', function ($scope, $ionicHistory, $rootScope) {
    $rootScope.pageCode = "jteqcllb";
    $scope.currentView = $ionicHistory.currentView().url.split('/')[2];

  })
  .controller('BZZYPageCtrl', function ($scope, getHomeEQ, $rootScope) {
    $scope.loading = true;

    getHomeEQ.query('bz').$promise.then(function (res) {
      $scope.BZZYInfo = res
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('EQYSKTypeCtrl', function ($scope, getHomeEQ, $rootScope) {
    $scope.loading = true;

    getHomeEQ.query('ysk').$promise.then(function (res) {
      $scope.YSKType = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('EQYSKListCtrl', function ($scope, $stateParams, getHomeEQ, $rootScope) {
    $scope.loading = true;

    $rootScope.pageCode = "ysklb";
    getHomeEQ.queryYSK($stateParams.params).$promise.then(function (res) {

      $scope.YSKList = res
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('HomeworkPageCtrl', function (ENV, $scope, $stateParams, getHomeWork, $rootScope, $ionicHistory) {
    $scope.currentView = $ionicHistory.currentView().url.split('/')[2];

    $rootScope.pageCode = "kczzdxq";
    $scope.loading = true;
    $scope.imgPath = ENV.imgpath;
    var homeworkInfo = $stateParams.params;
    $rootScope.toPushtitle = homeworkInfo.camp_name + homeworkInfo.course_name + homeworkInfo.course_lesson_num;

    homeworkInfo.type_code = "KCZZD";
    $scope.title = homeworkInfo.course_name;
    getHomeWork.get(homeworkInfo.id).$promise.then(function (res) {
      $scope.all = JSON.parse(JSON.stringify(homeworkInfo));
      $scope.all.course_lesson_num = Number($scope.all.course_lesson_num.replace(/[^0-9]/ig, ""));
      if (res.atts) {
        $scope.atts = JSON.parse(res.atts);
      }
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    })
  })
  .controller('EQHomeworkPageCtrl', function ($state, ENV, $scope, $stateParams, getAfterHomeWork, $rootScope) {
    $rootScope.pageCode = "jteqclxq";
    $scope.loading = true;
    $scope.imgPath = ENV.imgpath;
    var homeworkInfo = $stateParams.params;
    $rootScope.toPushtitle = homeworkInfo.course_name;
    homeworkInfo.type_code = "JTEQCL";
    $scope.title = homeworkInfo.course_name;
    getAfterHomeWork.get(homeworkInfo.id).$promise.then(function (res) {
      $scope.all = homeworkInfo;
      $scope.all.course_lesson_num = Number($scope.all.lesson_num || $scope.all.course_lesson_num);
      if (res.atts) {
        $scope.atts = JSON.parse(res.atts);
      }
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    })
  })
  //已消耗课程
  .controller('ConsumeLessonsCtrl', function ($scope, getYXHLessonsList, $rootScope) {
    $scope.loading = true;

    $rootScope.pageCode = "yxhkclb";
    getYXHLessonsList.query().$promise.then(function (res) {
      $scope.YXHLessonsList = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })

  //我的营队
  .controller('WDYDListCtrl', function ($scope, getWDYDList, $rootScope) {

    $rootScope.pageCode = "wdydlb";

    function init() {
      $scope.loading = true;

      getWDYDList.query().$promise.then(function (res) {
        $scope.WDYDList = res;
        $scope.OldWDYDList = res;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
      });
    }

    function getResult(val) {
      if (!$scope.OldWDYDList.length) return [];
      return $scope.OldWDYDList.filter(function (item) {
        return (item.camp_name.indexOf(val) > -1 || item.course_name.indexOf(val) > -1);
      })
    }

    init();
    $scope.onSearch = function (search) {
      if (event.which === 13) {
        if (search) {
          $scope.WDYDList = getResult(search);
        } else {
          init();
        }
      }
    };
  })
  //营队详情
  .controller('WDYDDetailCtrl', function ($scope, $stateParams, getWDYDList, $rootScope, popup, $state) {
    $rootScope.pageCode = "yxhkcxq";
    $rootScope.toPushtitle = $stateParams.params.camp_name;
    function init() {
      $scope.loading = true;

      getWDYDList.get($stateParams.params).$promise.then(function (res) {
        $scope.WDYDInfo = res;
        for (var i = 0; i < $scope.WDYDInfo.lessonInfo.length; i++) {
          if ($scope.WDYDInfo.lessonInfo[i].attendancetype === 'zs') {
            $scope.WDYDInfo.lessonInfo[i].cssClass = 'balanced';
          } else if ($scope.WDYDInfo.lessonInfo[i].attendancetype === 'qj') {
            $scope.WDYDInfo.lessonInfo[i].cssClass = 'assertive';
          } else if (!$scope.WDYDInfo.lessonInfo[i].attendancetype) {
            $scope.WDYDInfo.lessonInfo[i].cssClass = 'energized';
            break;
          }
        }
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
      });
    }

    init();
    var markInfo = {
      message: "请确认是否退出补课",
      closeButtonText: "取消",
      confirmButtonText: "确定"
    };
    $scope.quitTuition = function (item) {
      popup.popupConfirm(markInfo).then(function (res) {
        if (res) {
          getWDYDList.appOutLessons(item, $scope.WDYDInfo.campInfo).$promise.then(function (res) {
            popup.popupAlert({
              template: res.msgDesc,
              confirmButtonText: "关闭"
            });
            init();
          }).catch(function () {
            $rootScope.showNetworkAnomalyToastMessage();
          })
        }
      })
    }

    $scope.toPage = function (lessonInfo) {
      $state.go('tab.courses-onlineMessage', {
        params: {
          id: lessonInfo.id,
          course_name: $scope.WDYDInfo.campInfo.course_name,
          course_lesson_num: lessonInfo.lesson_num,
          type_code: "KJ",
          camp_id: $scope.WDYDInfo.campInfo.id,
          lesson_id: lessonInfo.id
        }
      })
    }
  })
  .controller('WYBKListCtrl', function ($scope, $rootScope, getWYBKInfo, popup, $ionicPopup, getOrder) {
    /* $scope.loading = true;*/

    $rootScope.pageCode = "wybk";
    $scope.pay = function (info) {
      popup.activityAgreementPopup($scope).then(function (res) {
        if (res) {
          popup.studentsPopup($scope).then(function (res) {
            if (info.price == 0) {
              getOrder.courseOrder(res, info).$promise.then(function (res) {
                $ionicPopup.alert({
                  template: res.msgDesc,
                  okText: '关闭'
                })
              }).catch(function () {
                $rootScope.showNetworkAnomalyToastMessage();
              })
            } else {
              $scope.payName = "课程";
              popup.selectPayMethod($scope, res, info).then(function (fnc) {
                if (fnc) fnc("courseOrder");
              });
            }
          })

        }
      })

    };


    /*getWYBKInfo.query().$promise.then(function (res) {
      $scope.list = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });*/
  })

;
