appService
//在读课程信息
  .factory('getZDKCInfo', function (User, $resource, ENV) {
    return {
      query: function () {
        return $resource(ENV.api + 'queryAppLearningLesson.action').query({
          _userId: User.getCurrentUserId()
        });
      }
    }
  })
  //补课中心
  .factory('getBKZXInfo', function (User, $resource, ENV, $rootScope) {
    return {
      query: function () {
        return $resource(ENV.api + 'getAppBKLessonsList.action').query({
          _userId: User.getCurrentUserId()
        });
      },
      makeUp: function (studentId, lessonId, bkLessonId) {

        return $resource(ENV.api + 'appBKLessons.action').save({
          _userId: User.getCurrentUserId(),
          _studentId: studentId,
          _lessonId: lessonId,
          _bkLessonId: bkLessonId,
          time: 0,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          pageCode: $rootScope.pageCode,
          openTime: moment().format('YYYY-MM-DD HH:mm:ss')
        });
      }
    }
  })
  //课程早知道
  .factory('getKCZZDInfo', function (User, $resource, ENV) {
    return {
      query: function (type) {
        return $resource(ENV.api + 'getAppTeachingHomeWork.action').query({
          _userId: User.getCurrentUserId(),
          _type: type
        });
      },
      queryYSK: function (item) {
        return $resource(ENV.api + 'getAppTeachingHomeWorkSKInfo.action').query({
          _userId: User.getCurrentUserId(),
          _courseId: item.course_id,
          _campId: item.camp_id
        });
      }
    }
  })
  //签到请假
  .factory('getQDQJInfo', function (User, $resource, ENV, $rootScope) {
    return {
      query: function (type) {
        return $resource(ENV.api + 'getAppSignList.action').query({
          _userId: User.getCurrentUserId(),
          _type: type
        });
      },
      saveAttendance: function (item, type) {
        return $resource(ENV.api + 'appSaveAttendance.action').save({
          _userId: User.getCurrentUserId(),
          _type: type || null,
          _lessonId: item.id,
          _studentId: item.studentid,
          _attendanceDesc: item._attendanceDesc || null,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          pageCode: type == 'zs' ? 'qd' : type,
          openTime: moment().format('YYYY-MM-DD HH:mm:ss')
        });
      }
    }
  })
  //作业查看
  .factory('getHomeWork', function ($resource, ENV) {
    return {
      get: function (id) {
        return $resource(ENV.api + 'getTeachingHomeWorkBase.action').get({
          _id: id
        });
      }
    }
  })
  //家庭EQ详情
  .factory('getHomeEQ', function ($resource, ENV, User) {
    return {
      query: function (type) {
        return $resource(ENV.api + 'getAppTeachingAfterHomeWork.action').query({
          _userId: User.getCurrentUserId(),
          _type: type
        });
      },
      queryYSK: function (item) {
        return $resource(ENV.api + 'getAppTeachingAfterHomeWorkSKInfo.action').query({
          _userId: User.getCurrentUserId(),
          _courseId: item.course_id,
          _campId: item.camp_id
        });
      }
    }
  })
  //课后作业
  .factory('getAfterHomeWork', function ($resource, ENV) {
    return {
      get: function (id) {
        return $resource(ENV.api + 'getTeachingAfterClassWorkBase.action').get({
          _id: id
        });
      }
    }
  })
  //我的营队
  .factory('getWDYDList', function (User, $resource, ENV, $rootScope) {
    return {
      query: function () {
        return $resource(ENV.api + 'getAppArrangeCourceList.action').query({
          _userId: User.getCurrentUserId()
        });
      },
      get: function (item) {
        return $resource(ENV.api + 'getAppArrangeCource.action').get({
          _userId: User.getCurrentUserId(),
          _campId: item.id
        });
      },
      appOutLessons: function (item, camp) {
        return $resource(ENV.api + 'appOutLessons.action').save({
          _userId: User.getCurrentUserId(),
          _bkLessonId: item.bklessonid,
          _campId: camp.id,
          _lessonId: item.id,
          _studentId: item.studentid,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          pageCode: $rootScope.pageCode,
          openTime: moment().format('YYYY-MM-DD HH:mm:ss')
        });
      }
    }
  })
  // 已消耗课程列表
  .factory('getYXHLessonsList', function ($resource, ENV, User) {
    return {
      query: function () {
        return $resource(ENV.api + 'getAppEndLesson.action').query({
          _userId: User.getCurrentUserId()
        });
      }
    }
  })
  //我要报课
  .factory('getWYBKInfo', function ($resource, ENV, User) {
    return {
      query: function () {
        return $resource(ENV.api + 'getAppAttendOrderList.action').query({
          _userId: User.getCurrentUserId()
        });
      }
    }
  })

;
