appCtrl
  .controller('HomeCtrl', function ($scope, GetInfo, User, $rootScope, searchPlaceholder, $state, popup, getOrder, $ionicPopup, $interval) {
    $rootScope.clearBadge();
    $rootScope.pageCode = "zy";
    $scope.playgroundInfo = [];
    $scope.newPlaygroundInfo = [];
    //活动报名
    $scope.payActivity = function (info) {
      var temp = JSON.parse(JSON.stringify(info));
      temp.id = temp.courseid;
      popup.activityAgreementPopup($scope).then(function (res) {
        if (res) {
          popup.studentsPopup($scope).then(function (res) {
            if (info.act_price == 0) {
              getOrder.activityOrder(res, {id: info.courseid}).$promise.then(function (res) {
                $ionicPopup.alert({
                  template: res.msgDesc,
                  okText: '关闭'
                })
              }).catch(function () {
                $rootScope.showNetworkAnomalyToastMessage();
              })
            } else {
              $scope.payName = "活动";
              popup.selectPayMethod($scope, res, temp).then(function (fnc) {
                if (fnc) fnc("activityOrder");  // activityOrder 活动订单 courseOrder 课程订单
              });
            }
          })
        }

      });

    };
    //搜索插件
    $scope.placeholder = searchPlaceholder;
    $scope.onSearch = function (search) {
      $state.go('tab.home-searchPage', {
        params: ''
      });
      if (event.which === 13) {
        $state.go('tab.home-searchPage', {
          params: search
        })
      }
    };
    //下拉刷新
    $scope.doRefresh = function () {
      $rootScope.clearBadge();
      GetInfo.query().$promise.then(function (res) {
        $scope.playgroundInfo = res;
        $scope.snapshot = JSON.parse(JSON.stringify(res));

        //时间实效性过滤
        function filterTime() {
          $scope.playgroundInfo.forEach(function (item, index) {
            item.push_date = moment($scope.snapshot[index].push_date).from(moment());
          })
        }

        //结束之前的轮询建立新的
        if ($rootScope.twTimeline) {
          $interval.cancel($rootScope.twTimeline);
        }
        filterTime();
        $rootScope.twTimeline = $interval(function () {
          filterTime();
        }, 60000);


      }).catch(function () {
        if (User.getCurrentUserId()) {
          $rootScope.showNetworkAnomalyToastMessage();
        }
      }).finally(function () {
        $scope.$broadcast('scroll.refreshComplete')
      });
    };
    //上拉加载数据
    $scope.loadMore = function () {
      GetInfo.query(null, $scope.playgroundInfo[$scope.playgroundInfo.length - 1].id).$promise.then(function (res) {
        $scope.newPlaygroundInfo = res;
        $scope.playgroundInfo = $scope.playgroundInfo.concat($scope.newPlaygroundInfo);
        $scope.snapshot = JSON.parse(JSON.stringify([$scope.snapshot].concat(res)));

        //时间实效性过滤
        function filterTime() {
          $scope.playgroundInfo.forEach(function (item, index) {
            item.push_date = moment($scope.snapshot[index].push_date).from(moment());
          })
        }

        //结束之前的轮询建立新的
        if ($rootScope.twTimeline) {
          $interval.cancel($rootScope.twTimeline);
        }
        filterTime();
        $rootScope.twTimeline = $interval(function () {
          filterTime();
        }, 60000);
      }).catch(function () {
        if (User.getCurrentUserId()) {
          $rootScope.showNetworkAnomalyToastMessage();
        }
      }).finally(function () {
        $scope.$broadcast('scroll.infiniteScrollComplete')
      });
    };


    $scope.doRefresh();


  })
  //查询页
  .controller('SearchPageCtrl', function ($scope, searchPlaceholder, $stateParams, $rootScope, GetInfo) {

    $rootScope.pageCode = "cx";
    $scope.search = $stateParams.params;
    $scope.placeholder = searchPlaceholder;
    $scope.playgroundInfo = [];
    $scope.newPlaygroundInfo = [];
    $scope.doRefresh = function () {
      $scope.loading = true;
      GetInfo.query(null, null, $scope.search).$promise.then(function (res) {
        $scope.newPlaygroundInfo = res;
        $scope.playgroundInfo = res;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
      });
    };
    //上拉加载数据
    $scope.loadMore = function () {
      GetInfo.query(null, $scope.playgroundInfo[$scope.playgroundInfo.length - 1].id, $scope.search).$promise.then(function (res) {
        $scope.newPlaygroundInfo = res;
        $scope.playgroundInfo = $scope.playgroundInfo.concat($scope.newPlaygroundInfo);
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.$broadcast('scroll.infiniteScrollComplete')
      });
    };

    $scope.onSearch = function (search) {
      if (event.which == 13) {
        $scope.search = event.target.value;
        $scope.doRefresh();
      }
    };
  })
  .controller('HZDTPageCtrl', function ($scope, getHZDTInfo, $rootScope) {
    $scope.loading = true;

    $rootScope.pageCode = "hdtjlb";
    getHZDTInfo.query("all").$promise.then(function (res) {
      $scope.HZDTInfo = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('GNListCtrl', function ($scope, getHZDTInfo, $rootScope) {
    $scope.loading = true;

    $rootScope.pageCode = "xygnlb";
    getHZDTInfo.query("gn").$promise.then(function (res) {
      $scope.GNList = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('GZListCtrl', function ($scope, getHZDTInfo, $rootScope) {
    $scope.loading = true;

    $rootScope.pageCode = "xygzlb";
    getHZDTInfo.query("gz").$promise.then(function (res) {
      $scope.GZList = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('XJListCtrl', function ($scope, getHZDTInfo, $rootScope) {
    $scope.loading = true;

    $rootScope.pageCode = "xyxjlb";
    getHZDTInfo.query("xj").$promise.then(function (res) {
      $scope.XJList = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })

  .controller('GNDetailCtrl', function ($scope, $stateParams, getHZDTInfo, $rootScope) {

    $scope.loading = true;

    $rootScope.pageCode = "xygnxq";
    getHZDTInfo.get($stateParams.params).$promise.then(function (res) {
      console.log(res);
      console.log($scope.$root.imgPath);
      $scope.signer = 'upload/';
      $scope.imageInfos = JSON.parse(res.atts);
      // if (res.paperInfo && res.paperInfo.length) {
      //   res.paperInfo = res.paperInfo.map(function (item) {
      //     if (item.subject) {
      //       item.subject = JSON.parse(item.subject);
      //     }
      //     return item;
      //   });
      // }
      $scope.imgTest = '648c318c-7009-43e1-8482-2938fba2194d.jpg';
      $scope.HZDTInfo = res;
      console.log($scope.$root.imgPath + $scope.signer + $scope.imgPathBasic);
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('GZDetailCtrl', function ($scope, $stateParams, $rootScope, getHZDTInfo, $sce) {

    $scope.infosArry = [];
    //初始化星级评分
    $scope.starArray = [
      {
        'id': 1,
        'image': 'img/home/backStar.png'
      },
      {
        'id': 2,
        'image': 'img/home/backStar.png'
      },
      {
        'id': 3,
        'image': 'img/home/backStar.png'
      },
      {
        'id': 4,
        'image': 'img/home/backStar.png'
      },
      {
        'id': 5,
        'image': 'img/home/backStar.png'
      },
    ];

    getHZDTInfo.get($stateParams.params).$promise.then(function (res) {
      if (res.paperInfo && res.paperInfo.length) {
        res.paperInfo = res.paperInfo.map(function (item) {
          if (item.subject) {
            item.subject = JSON.parse(item.subject);
          }
          item.images = [];
          // parseInt(item.optionid)
          //subject_type_code
          if(item.subject_type_code == 'radio') {
            if(item.optionnum) {
              $scope.score = parseInt(item.optionnum);
              item.images = $scope.setScore($scope.score);
            }
          } else {
              if(item.optionnum) {
                item.answer = item.optionnum;
              } else {
                item.answer = "暂无回答";
              }
          }
          $scope.infosArry.push(item);
        });
      }

      $scope.HZDTInfo = res;
      $scope.attention = $sce.trustAsHtml($scope.HZDTInfo.attention_content);
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });

    //评分
    $scope.setScore = function(score) {
      var image = [
        {
          'id': 1,
          'image': 'img/home/backStar.png'
        },
        {
          'id': 2,
          'image': 'img/home/backStar.png'
        },
        {
          'id': 3,
          'image': 'img/home/backStar.png'
        },
        {
          'id': 4,
          'image': 'img/home/backStar.png'
        },
        {
          'id': 5,
          'image': 'img/home/backStar.png'
        },
      ];

      for(var count = 0; count <= image.length-1; count++) {
        if(score >= count + 1) {
          image[count].images = 'img/home/star.png';
        } else {
          image[count].images = 'img/home/backStar.png';
        }
      }

      return image;
    };

    $rootScope.pageCode = "xygnxq";
    $scope.HZDTInfo = $stateParams.params;
  })
  .controller('XJDetailCtrl', function ($scope, $stateParams, $rootScope, getHZDTInfo, $sce) {

    $scope.infosArry = [];
    //初始化星级评分
    $scope.starArray = [
      {
        'id': 1,
        'image': 'img/home/backStar.png'
      },
      {
        'id': 2,
        'image': 'img/home/backStar.png'
      },
      {
        'id': 3,
        'image': 'img/home/backStar.png'
      },
      {
        'id': 4,
        'image': 'img/home/backStar.png'
      },
      {
        'id': 5,
        'image': 'img/home/backStar.png'
      },
    ];

    getHZDTInfo.get($stateParams.params).$promise.then(function (res) {
      if (res.paperInfo && res.paperInfo.length) {
        res.paperInfo = res.paperInfo.map(function (item) {
          if (item.subject) {
            item.subject = JSON.parse(item.subject);
          }
          item.images = [];
          // parseInt(item.optionid)
          //subject_type_code
          if(item.subject_type_code == 'radio') {
            if(item.optionnum) {
              $scope.score = parseInt(item.optionnum);
              item.images = $scope.setScore($scope.score);
            }
          } else {
            if(item.optionnum) {
              item.answer = item.optionnum;
            } else {
              item.answer = "暂无回答";
            }
          }
          $scope.infosArry.push(item);
        });
      }
      $scope.HZDTInfo = res;
      $scope.attention = $sce.trustAsHtml($scope.HZDTInfo.attention_content);
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });

    //评分
    $scope.setScore = function(score) {
      var image = [
        {
          'id': 1,
          'image': 'img/home/backStar.png'
        },
        {
          'id': 2,
          'image': 'img/home/backStar.png'
        },
        {
          'id': 3,
          'image': 'img/home/backStar.png'
        },
        {
          'id': 4,
          'image': 'img/home/backStar.png'
        },
        {
          'id': 5,
          'image': 'img/home/backStar.png'
        },
      ];

      for(var count = 0; count <= image.length-1; count++) {
        if(score >= count + 1) {
          image[count].images = 'img/home/star.png';
        } else {
          image[count].images = 'img/home/backStar.png';
        }
      }

      return image;
    };

    $rootScope.pageCode = "xygnxq";
    $scope.HZDTInfo = $stateParams.params;
  })
  //父母课堂
  .controller('FMKTPageCtrl', function ($scope, getNewsList, $rootScope) {
    $scope.loading = true;

    $rootScope.pageCode = "fmktlb";
    getNewsList.query("fmkc").$promise.then(function (res) {
      $scope.ZXHDInfo = res.map(function (item) {
        item.content = JSON.parse(item.content);
        return item;
      });
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    })
  })

  .controller('LYDTListCtrl', function ($scope, getNewsList, $rootScope) {
    $scope.loading = true;

    $rootScope.pageCode = "lydtlb";
    getNewsList.query("lydt").$promise.then(function (res) {
      $scope.NewsList = res.map(function (item) {
        item.content = JSON.parse(item.content);
        return item;
      })
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('LYDTDetailCtrl', function (GetInfo, $ionicPopup, $ionicModal, $sce, $scope, $stateParams, $rootScope, getClientMessageist, ENV) {
    $scope.loading = true;
    $rootScope.pageCode = "lydtxq";
    $scope.newMsg = {};
    $scope.params = $stateParams.params;
    $scope.lYtitle = $scope.params.content[0].title;
    $rootScope.toPushtitle = $scope.params.content[0].title;
    GetInfo.updateTWRead($scope.params.id);
    getClientMessageist.query($scope.params.id, $scope.params.content[0].subId).$promise.then(function (res) {
      $scope.newsInfo = res.map(function (item) {
        item.textcontent = $sce.trustAsHtml(item.textcontent);
        return item;
      });
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });

    function init() {
      $scope.replyInfo = {
        replyId: null,
        replyName: null,
        businessDesc: $scope.params.content[0].title,
        topicId: 0,
        parentId: null
      }
    }

    $scope.bindReply = function (info) {
      $scope.createrName = info.creater_name;
      $scope.mark = '@';
      $scope.atPerson = $scope.mark + $scope.createrName;
      //用于临时存储长度
      $scope.atMessagePersonLength = $scope.atPerson.length;
      $scope.atLsPerson = $scope.atPerson;
      $scope.newMsg.content = $scope.atPerson;
      $scope.replyInfo = {
        replyId: info.creater_id,
        businessDesc: info.business_desc,
        replyName: info.creater_name,
        topicId: info.topic_id === 0 ? info.id : info.topic_id,
        parentId: info.id
      };
      // $scope.modal.show();
      if($scope.atPerson.length != 0) {
        $scope.replayMark = 0;
        $scope.atPerson = '';
      }
    };
    init();

    function load() {
      getClientMessageist.queryMessage($scope.params.id).$promise.then(function (res) {
        $scope.onlineMessage = res;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      });
    }

    load();
    $ionicModal.fromTemplateUrl('templates/writeMessage.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function (modal) {
      $scope.modal = modal;
    });
    $scope.openModal = function () {
      $rootScope.clickMessage().then(function (res) {
        if (res) {
          $scope.modal.show();
        }
      });
    };
    $scope.closeModal = function () {
      $scope.modal.hide();
      init();
    };
    $scope.$on('$destroy', function () {
      $scope.modal.remove();
    });
    $scope.sendMessage = function (newMsg) {
      $scope.loading = true;
      var content = '';

      // atLsPerson
      if(newMsg.content.substring(0, $scope.atMessagePersonLength) == $scope.atLsPerson) {
        content = newMsg.content.substring($scope.atMessagePersonLength, newMsg.content.length);
      } else {
        init();
        content = newMsg.content;
      }

      if (content) {
        getClientMessageist.save(content, $scope.replyInfo, $scope.params).$promise.then(function (res) {
          load();
          $scope.newMsg = {};
          $rootScope.showToastMessage('等待审核');
          init();
          $scope.newMsg.content = '';
          $scope.loading = false;
        }).catch(function () {
          $rootScope.showNetworkAnomalyToastMessage();
        });
        // $scope.closeModal();

      } else {
        $rootScope.showToastMessage('发送内容为空');
      }
    };

    //swiper
    var swiper = new Swiper('#swiperShow', {
      slidesPerView: 4,
      spaceBetween: 1,
      pagination: {
        el: '.swiper-pagination',
        clickable: true
      }
    });

    $scope.isShow = false;

    /*隐藏弹出框*/
    $scope.hideAlert = function ($event) {

      if ($event.target.id) {
        $scope.isShow = false;
      }
    };

    $scope.showShare = function () {
      $scope.isShow = !$scope.isShow;

    };

    //封装分享的结果弹出框
    $scope.showAlert = function (title, result, titleDesc) {
      if (1 === result) {
        $scope.shareResult = "内容分享成功！";
      } else if (0 === result) {
        $scope.shareResult = "内容分享失败！";
      } else if (2 === result) {
        $scope.shareResult = "插件尚未安装！";
      }

      $ionicPopup.alert({
        title: title ? title : "提示",
        template: titleDesc ? titleDesc : $scope.shareResult
      });
    };


    //封装方法用来判断插件有没有安装
    $scope.isPsp = function (pspType) {

      if ('weChat' === pspType && "undefined" === typeof Wechat) { //判断微信插件

        return 0;
      } else if ('qq' === pspType && "undefined" === typeof QQSDK) { //判断QQ插件

        return 0;
      } else if ('sina' === pspType && "undefined" === typeof WeiboSDK) { //判断新浪插件

        return 0;
      } else {
        return 1;
      }
    };

    //share
    $scope.share = function (type) {
      //统一分享资源
      $scope.details = {
        shareUrl: ENV.imgpath + "staticHtml/tw/" + $scope.newsInfo[0].id + ".html",
        title: $scope.newsInfo[0].title,
        shareDesc: $scope.newsInfo[0].abstracts,
        shareImg: $rootScope.imgPath + $scope.newsInfo[0].filepath
      };
      /*
      *type:0 微信好友；1 微信朋友圈；2 QQ好友 3 QQ空间 4 新浪微博
      */
      if (0 === type) { //微信好友
        var msg = $scope.isPsp('weChat');

        if (0 === msg) {
          $scope.showAlert('安装提示', 2, '请安装微信插件！');
          return false;
        }

        //判断手机有没有装微信
        Wechat.isInstalled(function (installed) {
          if (!installed) {
            $scope.showAlert('安装提示', 2, '手机内暂无微信，请先安装微信，再进行分享！');
            return false
          }
        }, function (failReason) {
          $scope.showAlert('微信分享', 0, '分享内容至微信失败！' + failReason);
        });

        $scope.params = {
          scene: type,
          message: {
            title: $scope.details.title,
            thumb: $scope.details.shareImg,
            description: $scope.details.shareDesc,
            media: {
              type: Wechat.Type.LINK,
              webpageUrl: $scope.details.shareUrl    // 这里的webpageUrl要替换成你的页面url
            }
          }
        };

        //调用接口
        Wechat.share($scope.params, function () {
          $rootScope.showToastMessage("分享成功")
        }, function (reason) {
          $rootScope.showToastMessage("分享失败")
        });
      } else if (1 === type) { //微信朋友圈
        var msg = $scope.isPsp('weChat');

        if (0 === msg) {
          $scope.showAlert('安装提示', 2, '请安装微信插件！');
          return false;
        }

        //判断手机有没有装微信
        Wechat.isInstalled(function (installed) {
          if (!installed) {
            $scope.showAlert('安装提示', 2, '手机内暂无微信，请先安装微信，再进行分享！');
            return false
          }
        }, function (failReason) {
          $scope.showAlert('微信分享', 0, '分享内容至微信失败！' + failReason);
        });

        $scope.params = {
          scene: type,
          message: {
            title: $scope.details.title,
            thumb: $scope.details.shareImg,
            description: $scope.details.shareDesc,
            media: {
              type: Wechat.Type.LINK,
              webpageUrl: $scope.details.shareUrl    // 这里的webpageUrl要替换成你的页面url
            }
          }
        };

        //调用接口
        Wechat.share($scope.params, function () {
          $rootScope.showToastMessage("分享成功")
        }, function (reason) {
          alert(reason);
          $rootScope.showToastMessage("分享失败")
        });
      }
      /* else { //新浪微博
              var msg = $scope.isPsp('xina');
              if (0 === msg) {
                $scope.showAlert('安装提示', 2, '请安装微博插件！');
                return false;
              }
              try {
                var weibo = YCWeibo;
                //安装完插件之后的事情
                weibo.checkClientInstalled(function () {
                  var args = {};
                  args.url = $scope.details.shareUrl || '';
                  args.title = $scope.details.title || '';
                  args.description = $scope.details.shareDesc || '';
                  args.imageUrl = $scope.details.shareImg;
                  args.defaultText = "";
                  weibo.shareToWeibo(function () {
                    $scope.showAlert('微博分享', 1, '分享内容至微博成功！');
                  }, function (failReason) {
                    $scope.showAlert('微博分享', 0, '分享内容至微博失败！' + failReason);
                  }, args);
                }, function () {
                  $scope.showAlert('安装提示', 2, '您没有安装微博！');
                });
              } catch (err) {
                alert(err)
              }
            }*/
    }
  })
  .controller('onlineMessageCtrl', function ($scope, $rootScope, getStudentDynamicLy, $stateParams, getClientMessageist) {
    $scope.params = $stateParams.params;
    $scope.title = $scope.params.businessDesc || ($scope.params.course_name + '第' + $scope.params.course_lesson_num + '课');
    $rootScope.pageCode = "xylyxq";

    $rootScope.toPushtitle = $scope.title;

    function init() {
      $scope.replyInfo = {
        campId: null,
        lessonNum: null,
        replyId: null,
        replyName: null,
        businessDesc: $scope.params.businessDesc || ($scope.params.course_name + '第' + $scope.params.course_lesson_num + '课'),
        topicId: 0,
        parentId: null
      }
    }

    init();
    $scope.init = init;
    $scope.bindReply = function (info) {
      $scope.replyInfo = {
        campId: $scope.params.camp_id,
        lessonNum: $scope.params.course_lesson_num,
        replyId: info.creater_id,
        businessDesc: info.business_desc,
        replyName: info.creater_name,
        topicId: info.topic_id === 0 ? info.id : info.topic_id,
        parentId: info.id
      };
    };

    function load() {
      $scope.loading = true;
      //getClientMessageist
      if($scope.params.type_code == 'TW') {
        getClientMessageist.queryMessage($scope.params.id, $scope.params.type_code, $scope.params.camp_id, $scope.params.course_lesson_num).$promise.then(function(res) {
          $scope.twList = res;
        }).catch(function () {
          $rootScope.showNetworkAnomalyToastMessage();
        }).finally(function () {
          $scope.loading = false;
        });
      } else {
        getStudentDynamicLy.queryInfo($scope.params.id, $scope.params.type_code, $scope.params.camp_id, $scope.params.course_lesson_num).$promise.then(function (res) {
          $scope.list = res;
        }).catch(function () {
          $rootScope.showNetworkAnomalyToastMessage();
        }).finally(function () {
          $scope.loading = false;
        });
      }
    }

    load();
    $scope.$on("$ionicView.beforeLeave", function () {
      $rootScope.initUnRead();
    });

    $scope.bindReply = function (info) {
      $scope.createrName = info.creater_name;
      $scope.mark = '@';
      $scope.atPerson = $scope.mark + $scope.createrName;
      //用于临时存储长度
      $scope.atMessagePersonLength = $scope.atPerson.length;
      $scope.atLsPerson = $scope.atPerson;
      $scope.content = $scope.atPerson;
      $scope.replyInfo = {
        replyId: info.creater_id,
        businessDesc: info.business_desc,
        replyName: info.creater_name,
        topicId: info.topic_id === 0 ? info.id : info.topic_id,
        parentId: info.id
      };
      // $scope.modal.show();
      if($scope.atPerson.length != 0) {
        $scope.replayMark = 0;
        $scope.atPerson = '';
      }
    };

    $scope.sendMessage = function (content) {
      $scope.loading = true;
      if (content) {
        if($scope.twList) {
          // atLsPerson
          if(content.substring(0, $scope.atMessagePersonLength) == $scope.atLsPerson) {
            content = content.substring($scope.atMessagePersonLength, content.length);
          } else {
            init();
            content = content;
          }
          getClientMessageist.save(content, $scope.replyInfo, $scope.params).$promise.then(function (res) {
            load();
            $rootScope.showToastMessage('等待审核');
            init();
            $scope.content = '';
            $scope.loading = false;
          }).catch(function () {
            $rootScope.showNetworkAnomalyToastMessage();
          });
        } else {
          getStudentDynamicLy.save(content, $scope.replyInfo, $scope.params).$promise.then(function (res) {
            load();
            $scope.content = null;
            $rootScope.showToastMessage(res.msgDesc);
          }).catch(function () {
            $rootScope.showNetworkAnomalyToastMessage();
          });
        }
      } else {
        $rootScope.showToastMessage('发送内容为空');
      }
    }
  })


  .controller('msgListCtrl', function ($scope, getStudentDynamicLy, $rootScope) {
    $rootScope.pageCode = "xylylb";
    $scope.loading = true;

    getStudentDynamicLy.query().$promise.then(function (res) {
      $scope.list = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  //父母课堂活动详情
  .controller('FMKTXQPageCtrl', function ($scope, $stateParams, getClientMessageist, $rootScope, $ionicModal, GetInfo) {
    $scope.newMsg = {};
    $scope.params = $stateParams.params;
    $rootScope.toPushtitle = $scope.params.content[0].title;
    GetInfo.updateTWRead($scope.params.id);
    $rootScope.pageCode = "fmktxq";

    function init() {
      $scope.replyInfo = {
        replyId: null,
        replyName: null,
        businessDesc: $scope.params.content[0].title,
        topicId: 0,
        parentId: null
      }
    }

    $scope.bindReply = function (info) {
      $scope.createrName = info.creater_name;
      $scope.mark = '@';
      $scope.atPerson = $scope.mark + $scope.createrName;
      //用于临时存储长度
      $scope.atMessagePersonLength = $scope.atPerson.length;
      $scope.atLsPerson = $scope.atPerson;
      $scope.newMsg.content = $scope.atPerson;
      $scope.replyInfo = {
        replyId: info.creater_id,
        businessDesc: info.business_desc,
        replyName: info.creater_name,
        topicId: info.topic_id === 0 ? info.id : info.topic_id,
        parentId: info.id
      };
      // $scope.modal.show();
      if($scope.atPerson.length != 0) {
        $scope.replayMark = 0;
        $scope.atPerson = '';
      }
    };
    init();

    function load() {
      getClientMessageist.queryMessage($scope.params.id).$promise.then(function (res) {
        $scope.onlineMessage = res;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      });
    }

    load();
    $ionicModal.fromTemplateUrl('templates/writeMessage.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function (modal) {
      $scope.modal = modal;
    });
    $scope.openModal = function () {
      $rootScope.clickMessage().then(function (res) {
        if (res) {
          $scope.modal.show();
        }
      });
    };
    $scope.closeModal = function () {
      $scope.modal.hide();
      init();
    };
    $scope.$on('$destroy', function () {
      $scope.modal.remove();
    });
    $scope.sendMessage = function (newMsg) {
      // var content = newMsg.content;
      $scope.loading = true;
      var content = '';

      // atLsPerson
      if(newMsg.content.substring(0, $scope.atMessagePersonLength) == $scope.atLsPerson) {
        content = newMsg.content.substring($scope.atMessagePersonLength, newMsg.content.length);
      } else {
        init();
        content = newMsg.content;
      }
      if (content) {
        getClientMessageist.save(content, $scope.replyInfo, $scope.params).$promise.then(function (res) {
          load();
          $scope.newMsg = {};
          $rootScope.showToastMessage('等待审核');
          init();
          $scope.newMsg.content = '';
          $scope.loading = false;
        }).catch(function () {
          $rootScope.showNetworkAnomalyToastMessage();
        });
        $scope.closeModal();
      } else {
        $rootScope.showToastMessage('发送内容为空');
      }
    };
    $scope.loading = true;

    getClientMessageist.query(
      $scope.params.id,
      $scope.params.content[0].subId
    ).$promise.then(function (res) {
      $scope.Detail = res[0];
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
;

