appService
  .factory('getHZDTInfo', function ($resource, ENV, User) {
    return {
      query: function (type) {
        return $resource(ENV.api + 'getAppStudentDynamic.action').query({
          _userId: User.getCurrentUserId(),
          _type: type
        });
      },
      get: function (info) {
        return $resource(ENV.api + 'getAppStudentDynamicInfo.action').get({
          _id: info.id,
          _type: info.type
        });
      }
    }
  })
  .factory('getStudentDynamicLy', function ($resource, ENV, User, $rootScope) {
    return {
      query: function () {
        return $resource(ENV.api + 'getStudentDynamicLYList.action').query({
          _userId: User.getCurrentUserId()
        });
      },
      queryInfo: function (id, type, campId, lessonNum) {
        return $resource(ENV.api + 'getStudentDynamicLYInfo.action').query({
          _userId: User.getCurrentUserId(),
          _id: id,
          _type: type,
          _campId: campId,
          _lessonNum: lessonNum
        });
      },
      save: function (content, replyInfo, param) {
        return $resource(ENV.api + 'saveLeaveMessage.action').save({
          User: User.getCurrentUserId(),
          type: param.type_code,
          replyId: replyInfo.replyId,
          topic_id: replyInfo.topicId,
          business_desc: replyInfo.businessDesc,
          pid: replyInfo.parentId,
          content: content,
          business_id: param.id,
          campId: param.camp_id,
          lessonNum: param.course_lesson_num,
          lessonId: param.lesson_id,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          pageCode: $rootScope.pageCode,
          openTime: moment().format('YYYY-MM-DD HH:mm:ss')
        });
      }
    }
  })
  //新闻
  .factory('getNewsList', function ($resource, ENV, User) {
    return {
      query: function (type) {
        return $resource(ENV.api + 'getClientMessageistByType.action').query({
          _type: type,
          _userId: User.getCurrentUserId()
        });
      }
    }
  })
;
