appCtrl

  .controller('PersonalCtrl', function ($scope, $state, User, getPersonalMenu, $rootScope) {
    $rootScope.pageCode = "wd";
    $rootScope.verifyMessage();
    User.getCurrentUser().then(function (res) {
      $scope.personInfo = res;
    });
    $scope.personalMenu = getPersonalMenu.all();
  })
  .controller('SettingsCtrl', function ($scope, $ionicActionSheet, User, $state, $rootScope, $ionicHistory) {
    $rootScope.pageCode = "sz";
    $scope.logout = function () {
      var sheet;
      if (ionic.Platform.isAndroid()) {
        sheet = $ionicActionSheet.show({
          destructiveText: '<i class="icon ion-power assertive"></i> 退出登录',
          titleText: '确定退出当前登录帐号么?',
          cancelText: '取消',
          destructiveButtonClicked: function () {
            User.logout();
            $ionicHistory.nextViewOptions({
              historyRoot: true
            });
            $state.go('login');
            return true;
          }
        })
      } else {
        sheet = $ionicActionSheet.show({
          destructiveText: '退出登录',
          titleText: '确定退出当前登录帐号么?',
          cancelText: '取消',
          destructiveButtonClicked: function () {
            User.logout();
            $ionicHistory.nextViewOptions({
              historyRoot: true
            });
            $state.go('login');
            return true;
          }
        })
      }

    }


  })
  .controller('InfoPageCtrl', function ($scope, User, $rootScope) {
    $rootScope.pageCode = "grxx";
    $scope.loading = true;

    User.getCurrentUser().then(function (res) {
      $scope.userInfo = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('MyOrderPageCtrl', function ($scope, myOrder, $rootScope, $ionicPopup) {
    $scope.loading = true;
    $rootScope.pageCode = "wdddlb";
    $scope.deleteOrder = function (orderInfo, $index) {
      $ionicPopup.confirm({
        template: '确认删除该订单?!',
        cancelText: '取消',
        okText: '删除',
        okType: 'assertive-important'
      }).then(function (res) {
        if (res) {
          $scope.loading = true;
          myOrder.delete(orderInfo).$promise.then(function (res) {
            if (res.msgCode === "success") {
              $scope.myOrder.splice($index, 1)
            }
            $rootScope.showToastMessage(res.msgDesc);
          }).catch(function () {
            $rootScope.showNetworkAnomalyToastMessage();
          }).finally(function () {
            $scope.loading = false;
          });
        }
      })
    };
    myOrder.query().$promise.then(function (res) {
      $scope.myOrder = res;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })

  .controller('AttendanceRecordCtrl', function ($scope, getAttendanceRecord, popup, $rootScope, $timeout) {
    $scope.$on('$ionicView.beforeEnter', function() {
      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
      }
    });
    // $scope.timer = $timeout(function () {
    //   $scope.loading = false;
    //   $rootScope.showToastMessage("网络不稳定！");
    // }, 30000);

    var count = 1;
    var _type = 'ALL';
    var _lessonNum = null;
    var _content;
    //假设下拉获取的值是
    $scope.selectData = "ALL";
    $scope.classNum = null;
    $scope.content = '';

    //查询 三个参数
    $scope.search = function() {
      _type = $scope.selectData;
      _lessonNum = $scope.classNum;
      _content = $scope.content;
      $scope.doRefresh();
    };

    $rootScope.pageCode = "wdkqjllb";
    //刷新
    $scope.doRefresh = function () {
      count = 1;
      // $rootScope.isLoadingShow();
      $scope.loading = true;
      getAttendanceRecord.query(count, _type, _lessonNum, _content).$promise.then(function (res) {
        $scope.attendanceRecordList = res;
        $scope.newInfo = res;
        // $timeout.cancel($scope.timer);
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.$broadcast('scroll.refreshComplete');
        $scope.loading = false;
      });
    };
    $scope.doRefresh();
    $scope.loadMore = function () {
      count += 1;
      $scope.loading = true;
      getAttendanceRecord.query(count, _type, _lessonNum, _content).$promise.then(function (res) {
        $scope.newInfo = res;
        $scope.attendanceRecordList = $scope.attendanceRecordList.concat(res);
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
        $scope.$broadcast('scroll.infiniteScrollComplete')
      });
    };

    $scope.popup = function (item) {
      popup.popupAlert({
        title: item.camp_name,
        template: item.attendancetype === "qj" ? "请假原因:" + item.attendance_desc : "考勤时间" + item.attendancedate
      })
    };

    $scope.$on('$ionicView.leave', function() {
      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      }
    });
  })

  .controller('EQTestListPageCtrl', function ($scope, $rootScope, getEQtest) {
    $rootScope.pageCode = "qscslb";
    var init = function () {
      $scope.loading = true;

      return getEQtest.getList(page).$promise.then(function (res) {
        $scope.list = res;
        res.length === 20 ? $scope.hasMore = true : $scope.hasMore = false;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
      });
    };
    var load = function () {
      return getEQtest.getList(page).$promise.then(function (res) {
        $scope.list = $scope.list.concat(res);
        res.length === 20 ? $scope.hasMore = true : $scope.hasMore = false;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      });
    };
    var page = 1;
    $scope.hasMore = false;
    init();
    //下拉刷新
    $scope.doRefresh = function () {
      page = 1;
      init().finally(function () {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };
    //上拉加载数据
    $scope.loadMore = function () {
      page++;
      load().finally(function () {
        $scope.$broadcast('scroll.infiniteScrollComplete')
      });
    };

    //进入解封cordova keyboard
    // $scope.$on('$ionicView.beforeLeave', function() {
    //   if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
    //     cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    //   }
    // });
  })
  .controller('EQTestDetailPageCtrl', function ($scope, $rootScope, $stateParams, getEQtest) {
    $rootScope.pageCode = "qscsxq";
    $scope.loading = true;
    $rootScope.toPushtitle = $stateParams.params.paperName;
    getEQtest.get($stateParams.params.id, $stateParams.params.test_example_id).$promise.then(function (res) {

      var listTotal = [];
      for (var i = 0; i < res.details.length; i++) {
        for (var key in res.details[i]) {
          var a = {};
          a.title = key;
          a.detail = res.details[i][key];
          listTotal.push(a)
        }
      }
      $scope.results = res;
      $scope.listTotal = listTotal;
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
    //老代码
    $scope.getPdfReportFile = function (req) {
      getEQtest.getPDF(req)
    };
  })
  .controller('WJDCListPageCtrl', function ($scope, $rootScope, getQuestionnaire) {
    $scope.loading = true;

    $rootScope.pageCode = "dcwjlb";

    function init() {
      getQuestionnaire.query().$promise.then(function (res) {
        $scope.list = res;
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.$broadcast('scroll.refreshComplete');
        $scope.loading = false;
      });
    }

    init();
    $scope.doRefresh = init;
    $scope.open = function (item) {
      getQuestionnaire.open(item)
    };
  })
  .controller('StudentInfoPageCtrl', function ($scope, $rootScope, getStudentInfo, $ionicPopup) {
    $scope.loading = true;
    $scope.editStatus = true;
    $scope.navClass = ["fa", "fa-pencil-square-o"];
    $scope.edit = function (info) {
      if (info.name && info.brithday && info.mobile) {

        $scope.editStatus = !$scope.editStatus;
        if ($scope.editStatus) {
          getStudentInfo.save(info).$promise.then(function (res) {
            $rootScope.showToastMessage(res.msgDesc)
          }).catch(function (err) {
            $rootScope.showToastMessage(err.msgDesc)
          });
          $scope.navClass = ["fa", "fa-pencil-square-o"];


        } else {
          $scope.navClass = ["icon", "ion-checkmark-round"];
        }
      } else {
        $ionicPopup.alert({
          template: '带*必填'
        })
      }
    };

    $rootScope.pageCode = "xxxx";
    getStudentInfo.query().$promise.then(function (res) {
      $scope.studentInfo = res;
      $scope.studentInfo = $scope.studentInfo.map(function (item) {
        item.brithday = new Date(item.brithday)
        return item;
      });
    }).catch(function () {
      $rootScope.showNetworkAnomalyToastMessage();
    }).finally(function () {
      $scope.loading = false;
    });
  })
  .controller('changePassword', function ($scope, $rootScope, updateUser, $stateParams, $ionicHistory, $state, User) {
    if ($stateParams.params) {
      $scope.id = $stateParams.params.id
    }
    $rootScope.pageCode = "xgmm";
    $scope.Date = {
      oldPsw: '',
      newPsw: '',
      confirmNewPsw: ''
    };
    $scope.show = {};
    //写过最蠢的验证,有时间再改
    $scope.verification = function (flag) {
      if (flag === 1) {
        $scope.oldPswStyle = $scope.Date.oldPsw.length > 0 ? "psw-balanced" : "psw-assertive";
        if ($scope.oldPswStyle === "psw-assertive") {
          $scope.show.oldPsw = true;
          $scope.show.text = "必填";
        } else {
          $scope.show.oldPsw = false;
        }
      } else if (flag === 2) {
        $scope.newPswStyle = $scope.Date.newPsw.length > 0 ? "psw-balanced" : "psw-assertive";
        if ($scope.newPswStyle === "psw-assertive") {
          $scope.show.newPsw = true;
          $scope.show.text = "必填";
        } else {
          $scope.show.newPsw = false;
          if ($scope.Date.confirmNewPsw.length > 0) {
            if ($scope.Date.confirmNewPsw === $scope.Date.newPsw) {
              $scope.show.confirmNewPsw = false;
              $scope.show.newPsw = false;
              $scope.confirmNewPswStyle = "psw-balanced";
              $scope.newPswStyle = "psw-balanced";
            } else {
              $scope.confirmNewPswStyle = "psw-assertive";
              $scope.newPswStyle = "psw-assertive";
              $scope.show.text = "新密码不一致";
              $scope.show.confirmNewPsw = true;
              $scope.show.newPsw = true;
            }
          } else {
            $scope.confirmNewPswStyle = "psw-balanced";
            $scope.show.confirmNewPsw = false;
          }
        }
      } else if (flag === 3) {
        if ($scope.Date.confirmNewPsw.length > 0) {
          if ($scope.Date.confirmNewPsw === $scope.Date.newPsw) {
            $scope.show.confirmNewPsw = false;
            $scope.show.newPsw = false;
            $scope.confirmNewPswStyle = "psw-balanced";
            $scope.newPswStyle = "psw-balanced";
          } else {
            $scope.confirmNewPswStyle = "psw-assertive";
            $scope.newPswStyle = "psw-assertive";
            $scope.show.text = "新密码不一致";
            $scope.show.confirmNewPsw = true;
            $scope.show.newPsw = true;
          }
        } else {
          $scope.confirmNewPswStyle = "psw-assertive";
          $scope.show.confirmNewPsw = true;
          $scope.show.text = "必填";
        }
      }
    };
    $scope.onSubmit = function () {

      if ($scope.Date.confirmNewPsw.length > 0 && $scope.Date.newPsw.length > 0 && $scope.Date.oldPsw.length > 0 && $scope.Date.confirmNewPsw === $scope.Date.newPsw) {
        if ($scope.Date.confirmNewPsw === "111111") {
          $rootScope.showToastMessage("不能设置为初始密码");
        } else {
          $scope.loading = true;
          updateUser.updateUserPwd($scope.Date.confirmNewPsw, $scope.Date.oldPsw, $scope.id).$promise.then(function (res) {
            $rootScope.showToastMessage(res.msg);
            User.logout();
            $ionicHistory.nextViewOptions({
              historyRoot: true
            });
            $state.go('login');
          }).catch(function () {
            $rootScope.showNetworkAnomalyToastMessage();
          }).finally(function () {
            $scope.loading = false;
          });
        }
      } else {
        $scope.verification(1);
        $scope.verification(2);
        $scope.verification(3);
      }
    }
  })
  .controller('classScheduleCtrl', function ($scope, $rootScope, $compile, uiCalendarConfig, $timeout, getLessonSchedule, $ionicPopup) {
    $rootScope.pageCode = "kcb";
    $scope.events = {};

    //获取事件源
    function setMonthCS(info) {
      var set = {};
      info.forEach(function (item) {
        set[new Date(moment(item.begin_date).format('YYYY-MM-DD'))] = 0;
      });
      var heavyTimes = Object.keys(set);

      $scope.events = heavyTimes.map(function (time) {
        return {
          title: '有课',
          start: new Date(time),
          allDay: true,
          className: ['customFeed', 'event-azure'],
          // id: item.id
        }
      });
      return $scope.events;
    }

    /* event source that pulls from google.com */
    $scope.eventSource = {
      url: "http://www.google.com/calendar/feeds/usa__en%40holiday.calendar.google.com/public/basic",
      className: 'gcal-event',           // an option!
      currentTimezone: 'America/Chicago' // an option!
    };
    /* event source that contains custom events on the scope */
    $scope.eventsF = function (start, end, timezone, callback) {
      $scope.loading = true;
      getLessonSchedule.getLessonSchedule({
        begin: start.format("YYYY-MM-DD"),
        end: end.format("YYYY-MM-DD")
      }).$promise.then(function (res) {
        var events = setMonthCS(res);
        callback(events);
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $scope.loading = false;
      })
    };
    /* Render Tooltip */
    $scope.eventRender = function (event, element, view) {
      element.attr({
        'tooltip': event.title,
        'tooltip-append-to-body': true
      });
      $compile(element)($scope);
    };
    $scope.alertEventOnClick = function (item) {
      $scope.dayLoading = true;
      getLessonSchedule.getLessonSchedule({
        begin: item.start.format("YYYY-MM-DD"),
        end: item.start.format("YYYY-MM-DD")
      }).$promise.then(function (res) {
        $scope.onDayList = res
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $timeout(function () {
          $scope.dayLoading = false;
        }, 500)
      });
      //item是点击的对象
      $ionicPopup.show({
        title: '', // String. The title of the popup.
        subTitle: '', // String (optional). The sub-title of the popup.
        templateUrl: 'templates/personal/calendarPop.html', // String (optional). The URL of an html template to place in the popup   body.
        scope: $scope,
        buttons: [{
          text: '关闭',
          type: 'positive',
          onTap: function () {
            return true;
          }
        }]
      });
    };
    /* config object */
    $scope.uiConfig = {
      calendar: {
        height: 450,
        editable: true,
        dayNames: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
        dayNamesShort: ["星期日", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六"],
        monthNames: ['一月', '二月', '三月', '四月', '五月', '六月', '七月',
          '八月', '九月', '十月', '十一月', '十二月'],
        titleFormat: {
          month: 'YYYY MMMM'
        },
        header: {
          left: '',
          center: 'title',
          right: 'today prev,next'
        },
        buttonText: {
          today: '今日'
        },
        eventClick: $scope.alertEventOnClick
      }
    };
    $scope.eventSources = [$scope.events, $scope.eventSource, $scope.eventsF];
  })
;
