appService
  .factory('getEQtest', function ($resource, User, ENV, $timeout, $cordovaTransfer, $ionicLoading, $ionicPopup, $cordovaFileOpener, $rootScope, popup) {
    return {
      getList: function (page) {
        return $resource(ENV.api + 'searchWeiXinTestPaperList.action').query({
          _page: page,
          _perPage: 20,
          _userId: User.getCurrentUserId()
        });
      },
      get: function (id, testExampleId) {
        return $resource(ENV.api + 'getWeiXinTestPaperResult.action').get({
          _id: id,
          _paperId: testExampleId
        })
      },
      getReportPath: function (id) {
        return $resource(ENV.api + 'getTestPaperReportPath.action', {}, {
          get: {
            method: 'get',
            isArray: false,
            params: {
              _id: id
            }
          }
        })
      },
      getPDF: function (req) {
        this.getReportPath(req).get(function (r) {
          if (r != null && r != "" && r.flag) {
            var url = ENV.imgpath + r.idpath;
            url = url.replace(/\\/g, "/");
            var trustHosts = true;
            var options = {};
            $ionicLoading.show({
              template: "加载中......：0%"
            });

            if (ionic.Platform.isAndroid()) {
              try {
                window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                  //请求成功   获取download文件夹 若不存在则创建该文件夹
                  fileSystem.root.getDirectory('download', {//
                    create: true,
                    exclusive: false
                  }, function (entry) {
                    var targetPath = entry.toURL() + '//报告.pdf';
                    //APP下载存放的路径，可以使用cordova file插件进行相关配置
                    //新的下载
                    var fileTransfer = new FileTransfer();
                    fileTransfer.onprogress = function (progress) {
                      //进度，这里使用文字显示下载百分比
                      var downloadProgress = (progress.loaded / progress.total) * 100;

                      (function load() {
                        $ionicLoading.show({
                          template: "已经下载：" + Math.floor(downloadProgress) + "%"
                        });
                      })();
                      if (downloadProgress > 99 && response.is_force_update !== "是") {
                        $ionicLoading.hide();
                      }
                    };
                    fileTransfer.download(url, targetPath, function (result) {
                      // 打开下载下来的APP
                      $cordovaFileOpener.open(targetPath, 'application/pdf'
                      ).then(function () {
                        // 成功
                      }, function (err) {
                        // 错误
                        alert('打开文件失败')
                      });
                      $ionicLoading.hide();
                    }, function (err) {
                      $ionicLoading.hide();
                      popup.popupAlert({
                        template: "下载失败"
                      })
                    }, trustHosts, options);
                  }, function () {
                    alert('创建文件夹失败');
                  });
                }, function () {
                  alert('创建文件夹失败');
                });
              } catch (e) {
                alert('系统异常')
              }
            } else {
              var url = ENV.imgpath + r.idpath;
              url = url.replace(/\\/g, "/");
              // 打开下载下来的PDF
              $cordovaFileOpener.open(url, 'application/pdf'
              ).then(function () {
                // 成功
              }, function (err) {
                $ionicLoading.hide();
                // 错误
              }, function (progress) {
                //进度，这里使用文字显示下载百分比
                $timeout(function () {
                  var downloadProgress = (progress.loaded / progress.total) * 100;
                  $ionicLoading.show({
                    template: "已经加载：" + Math.floor(downloadProgress) + "%"
                  });
                  if (downloadProgress > 99) {
                    $ionicLoading.hide();
                  }
                })
              });
            }

          } else {
            if (r.type == 0) {
              var confirmPopup = $ionicPopup.alert({
                title: '<div style="text-align: center;font-size: large;font-weight: bold">提示</div>',
                template: '<div style="text-align: center">您孩子的测试问卷类型无pdf报告！</div>',
                okText: '确定'
              });
            } else {
              var confirmPopup = $ionicPopup.alert({
                title: '<div style="text-align: center;font-size: large;font-weight: bold">提示</div>',
                template: '<div style="text-align: center">您孩子的的报告暂时未生成，请10分钟后再查看！</div>',
                okText: '确定'
              });
            }
          }
        }, function () {
          $rootScope.showNetworkAnomalyToastMessage();
        })
      }
    }
  })
  //问卷调查
  .factory('getQuestionnaire', function ($resource, User, ENV, $rootScope) {
    return {
      query: function () {
        return $resource(ENV.api + 'getPaperSendInfo.action').query({
          _userId: User.getCurrentUserId()
        })
      },
      open: function (r) {
        var teacher_id = r.teacher_id;
        var exam_id = r.exam_id;
        var month = r.month;
        var parent_id = r.parent_id;
        var question_url = ENV.ipAddress + 'questionRelationManager/initClient.action?_teacherId=' + teacher_id + '&_examId=' + exam_id + '&_month=' + month + '&_parentId=' + parent_id
          + '&_model=' + $rootScope.phone.model + '&_uuid=' + $rootScope.phone.uuid + '&_openTime=' + moment().format('YYYY-MM-DD HH:mm:ss') + '&_userId=' + User.getCurrentUserId();
        window.open(question_url, '_blank', 'location=yes')
      }
    }
  })
  //考勤记录
  .factory('getAttendanceRecord', function ($resource, User, ENV, $timeout) {
    return {
      query: function (count, type, lessonNum, content) {
        return $resource(ENV.api + 'appGetAttendanceRecord.action').query({
          _userId: User.getCurrentUserId(),
          _page: count,
          _type: type,
          _lessonNum: lessonNum,
          _content: content
        });
      }
    }
  })
  //我的订单
  .factory('myOrder', function ($resource, User, ENV) {
    return {
      query: function () {
        return $resource(ENV.api + 'getAppOrderList.action').query({
          _userId: User.getCurrentUserId()
        });
      },
      delete: function (orderInfo) {
        return $resource(ENV.api + 'delOrder.action').save({
          _userId: User.getCurrentUserId(),
          _id: orderInfo.id
        });
      }
    }
  })
  //学生信息
  .factory('getStudentInfo', function ($resource, User, ENV, $filter, $rootScope) {
    return {
      query: function () {
        return $resource(ENV.api + 'getAppStudentInfo.action').query({
          _userId: User.getCurrentUserId()
        });
      },
      save: function (info) {
        return $resource(ENV.api + 'saveStudentInfo.action').save({
          _userId: User.getCurrentUserId(),
          _studentId: info.id,
          _studentName: info.name || null,
          _address: info.address || null,
          _birthday: $filter('date')(info.brithday, "yyyy-MM-dd") || null,
          _phone: info.mobile || null,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          pageCode: $rootScope.pageCode,
          openTime: moment().format('YYYY-MM-DD HH:mm:ss')
        });
      }
    }
  })
  .factory('updateUser', function ($resource, User, ENV, $rootScope) {
    return {
      updateUserPwd: function (newPwd, oldPwd, userid) {
        return $resource(ENV.api + 'checkPassWord.action').get({
          _userId: User.getCurrentUserId() || userid,
          _newPas: newPwd,
          _oldPas: oldPwd,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          pageCode: $rootScope.pageCode,
          openTime: moment().format('YYYY-MM-DD HH:mm:ss')
        })
      }
    }
  })
  .factory('getLessonSchedule', function ($resource, User, ENV) {
    return {
      getLessonSchedule: function (dates) {
        return $resource(ENV.api + 'getLessonSchedule.action').query({
          _userId: User.getCurrentUserId(),
          _beginDate: dates.begin,
          _endDate: dates.end
        })
      }
    }
  })
;
