var appService = angular.module('starter.services', [])
  .constant('ENV', {
    "accessToken": '',
    "debug": false,
    "iosUpdateUrl": 'https://itunes.apple.com/lookup',
    "iosAppKey": 1118812571,
    // "api": 'http://192.168.117.63:8080/androidManager/',
    // "imgpath": 'http://192.168.117.63:8080/projectdata/',
    // "ipAddress": 'http://192.168.117.63:8080/',
    // "api": 'http://192.168.117.120:8080/androidManager/',
    // "imgpath": 'http://192.168.117.120:8080/projectdata/',
    // "ipAddress": 'http://192.168.117.120:8080/',
    // "api": 'http://oa.pngm.com:10009/jxpx/androidManager/',
    // "imgpath": 'http://oa.pngm.com:10009/jxpx/projectdata/',
    // "ipAddress": 'http://oa.pngm.com:10009/jxpx/',
    "api": 'http://oa.pngm.com:8889/jxpx/androidManager/',
    "imgpath": 'http://oa.pngm.com:8889/jxpx/projectdata/',
    "ipAddress": 'http://oa.pngm.com:8889/jxpx/',

    "appleId": 'id1118812571',
    'appId': 1118812571,
    'version': '11.0.6'
  })
  .factory('popup', function ($ionicPopup, getStudentByparent, $ionicLoading, $rootScope, $q, pay, getOrder, getWecahtOrder, User) {
      //管理员弹窗设置错误
      var popupError = function () {
        $ionicPopup.alert({
          title: '管理员设置错误',
          template: '请联系管理员',
          okText: '关闭'
        })
      };
      //弹窗输入
      var popupPrompt = function (item) {
        if (item && item.title && item.confirmButtonText && item.closeButtonText && item.placeholder) {
          return $ionicPopup.prompt({
            title: item.title,
            inputType: 'text',
            inputPlaceholder: item.placeholder,
            cancelText: item.closeButtonText,
            cancelType: 'bar-assertive',
            okText: item.confirmButtonText,
            okType: 'button-positive'
          });
        } else {
          popupError();
          return new Promise(function (resolve, reject) {
            resolve(false)
          });
        }
      }
      //弹窗确认
      var popupConfirm = function (item) {
        if (item && item.message) {
          var myPopup = $ionicPopup.confirm({
            title: item.title ? item.title : "",
            template: item.message,
            cancelText: item.closeButtonText ? item.closeButtonText : '取消',
            cancelType: 'bar-assertive',
            okText: item.confirmButtonText ? item.confirmButtonText : '确定',
            okType: 'button-positive'
          });
          return myPopup.then(function (res) {
            if (res && item.callback) {
              item.callback(item);
            }
            return res;
          })
        } else {
          popupError();
          return new Promise(function (resolve, reject) {
            resolve(false)
          });
        }
      };
      //弹窗提示
      var popupAlert = function (alertItem) {
        if (alertItem && alertItem.template) {
          return $ionicPopup.alert({
            title: alertItem.title,
            template: alertItem.template,
            okText: alertItem.confirmButtonText ? alertItem.confirmButtonText : "关闭"
          }).then(function (res) {
              return res;
            }
          )
        } else {
          popupError();
          return new Promise(function (resolve, reject) {
            resolve(false)
          });
        }
      };

      // 协议弹窗
      var activityAgreementPopup = function ($scope) {
        return $ionicPopup.show({
          templateUrl: 'templates/activityAgreement.html',
          title: '课程协议',
          subTitle: '请认真阅读课程协议内容',
          cssClass: 'agreement',
          scope: $scope,
          buttons: [
            {text: '取消'},
            {
              text: '<b>确定</b>',
              onTap: function (e) {
                if (this.scope.agreement) {
                  return true;
                } else {
                  $rootScope.showToastMessage('请确认协议');
                  e.preventDefault();
                }
              }
            }
          ]
        });
      };

      var studentsPopup = function ($scope) {
        var q = $q.defer();
        $scope.select = {};
        $ionicLoading.show();
        getStudentByparent.query().$promise.then(function (res) {
          $scope.students = res;
          if (res.length === 1) {
            $scope.select[res[0].student_id] = true;
          }
          var myPopup = $ionicPopup.show({
            templateUrl: 'templates/studentCheckbox.html',
            title: '请选中想要报名的孩子',
            subTitle: '(多选)',
            scope: $scope,
            buttons: [
              {text: '取消'},
              {
                text: '<b>完成</b>',
                type: 'button-positive',
                onTap: function (e) {
                  var selects = [];
                  for (var key in $scope.select) {
                    if ($scope.select[key] === true) {
                      selects.push(Number(key))
                    }
                  }
                  if (selects.length < 1) {
                    $rootScope.showToastMessage('至少选择一个孩子');
                    e.preventDefault();
                  } else {
                    q.resolve(selects);
                  }
                }
              }
            ]
          });
        }).catch(function () {
          q.reject(false);
          $rootScope.showNetworkAnomalyToastMessage();
        }).finally(function () {
          $ionicLoading.hide();
        });
        return q.promise;
      };
      var selectPayMethod = function ($scope, students, info) {
        $scope.payInfo = {
          checkWay: 'aliPay'
        };

        $scope.thePrice = info.price || info.act_price || info.actPrice || info.other.act_price;
        $scope.balanceBlur = function () {
          $scope.payInfo.inputBalance = Number(numeral($scope.payInfo.inputBalance).format('0.00'))
          if ($scope.payInfo.inputBalance > $scope.payInfo.balance) {
            $scope.payInfo.inputBalance = $scope.payInfo.balance < $scope.thePrice ? $scope.payInfo.balance : $scope.thePrice;
          } else if ($scope.payInfo.inputBalance < 0) {
            $scope.payInfo.inputBalance = 0;
          }
          return $scope.payInfo.inputBalance;
        };
        $scope.balanceKeyup = function () {
          if ($scope.payInfo.inputBalance != null) {
            $scope.payInfo.inputBalance = Number(numeral($scope.payInfo.inputBalance).format('0.00'));


            if ($scope.payInfo.inputBalance > $scope.payInfo.balance) {
              $scope.payInfo.inputBalance = $scope.payInfo.balance < $scope.thePrice ? $scope.payInfo.balance : $scope.thePrice;
            } else if ($scope.payInfo.inputBalance < 0) {
              $scope.payInfo.inputBalance = 0;
            }
          }
        };
        $scope.balanceChange = function (valid) {
          if (valid && valid.min) {
            $scope.payInfo.inputBalance = 0;
          } else if (valid && valid.max) {
            $scope.payInfo.inputBalance = $scope.payInfo.balance < $scope.thePrice ? $scope.payInfo.balance : $scope.thePrice;
          }
          return $scope.payInfo.inputBalance;
        };
        // 加载余额
        $ionicLoading.show();
        User.getCurrentUser().then(function (res) {
          $scope.payInfo.balance = Number(res.balance.replace(/\¥\s?|(,*)/g, ''));
          $scope.payInfo.inputBalance = $scope.payInfo.balance < $scope.thePrice ? $scope.payInfo.balance : $scope.thePrice;
        }).catch(function () {
          $rootScope.showToastMessage('获取余额失败')
        }).finally(function () {
          $ionicLoading.hide();
        });

        function toAppPay(deductionAmount) {
          if ($scope.payInfo.checkWay === 'aliPay') {
            return function (orderFuc) {
              pay.alipay(students, info, getOrder[orderFuc], deductionAmount);
            };
          } else if ($scope.payInfo.checkWay === 'weChat') {
            return function (orderFuc) {
              pay.wechatPay(students, info, getWecahtOrder[orderFuc], deductionAmount);
            };
          }
        }


        var myPopup = $ionicPopup.show({
          title: '请选择支付方式',
          templateUrl: 'templates/paySelect.html',
          scope: $scope,
          buttons: [
            {text: '取消'},
            {
              text: '<b>支付</b>',
              onTap: function (e) {
                return toPay();
              }
            }
            /* {
               text: '<img src="./img/share/alipay.png" class="imageSize"/>',
               type: ['button-clear', 'flex-none'],
               onTap: function (e) {
                 var dopay = function (orderFuc) {
                   pay.alipay(students, info, getOrder[orderFuc]);
                 };
                 return dopay;
               }
             },
             {
               text: '<img src="./img/share/weixin.png" class="imageSize"/>',
               type: ['button-clear', 'flex-none'],
               onTap: function (e) {
                 var dopay = function (orderFuc) {
                   pay.wechatPay(students, info, getWecahtOrder[orderFuc]);
                 };
                 return dopay;
               }
             }*/
          ]
        });

        function toPay() {
          var balance;
          if ($scope.payInfo.checkBalance) {
            balance = $scope.balanceChange();
            // 抵扣后金额
            var deductedAmount = $scope.thePrice - $scope.payInfo.inputBalance;
            if (deductedAmount > 0) {
              return toAppPay(balance);
            } else {
              return function (orderFuc) {
                pay.balancePay(students, info, getOrder[orderFuc], balance);
              };
            }
          } else {
            return toAppPay(0);
          }
        }


        return myPopup;
      }
      return {
        popupError: popupError,
        popupAlert: popupAlert,
        popupConfirm: popupConfirm,
        popupPrompt: popupPrompt,
        studentsPopup: studentsPopup,
        selectPayMethod: selectPayMethod,
        activityAgreementPopup: activityAgreementPopup
      }
    }
  )
  .factory('GetInfoOperate', function (popup, GetInfo) {
    var registrationActivities = function (info) {
      return popup.popupConfirm(info);
    };
    var attendance = function (info) {
      return popup.popupConfirm(info).then(function (res) {
        if (res) {
          GetInfo.remove(info)
        }
        return res;
      })
    };
    var course = function (info) {
      return new Promise(function (resolve) {
        resolve(true)
      });
    };
    return {
      registrationActivities: registrationActivities,
      attendance: attendance,
      course: course
    }
  })
  .factory('GetInfo', function ($resource, User, ENV) {
    return {
      query: function (type, id, search) {
        return $resource(ENV.api + 'getPushMessageList.action').query({
          _userId: User.getCurrentUserId(),
          _type: type || null,
          _id: id || null,
          _queryCondition: encodeURI(search) || null
        })
      },
      updateRead: function (id) {
        return $resource(ENV.api + 'updateMessageToRead.action').save({
          _userId: User.getCurrentUserId(),
          _id: id
        })
      },
      updateTWRead: function (id) {
        return $resource(ENV.api + 'updateMessageToReadByBusId.action').save({
          _userId: User.getCurrentUserId(),
          _id: id
        })
      }
    }
  })
  //首页背景图片
  .factory('getBackgroundImgs', function ($resource, ENV, User) {
    /*    var img = [
          [{
            url: "img/back1.jpg",
            id: 1
          }],
          [{
            url: "img/back2.jpg",
            id: 2
          }]
        ];*/
    return {
      all: function () {
        return img;
      },
      remove: function (info) {
        img.splice(img.indexOf(info), 1);
      },
      get: function (imgId) {
        for (var i = 0; i < img.length; i++) {
          if (img[i].id === parseInt(imgId)) {
            return img[i];
          }
        }
        return null;
      },
      query: function (type) {
        return $resource(ENV.api + 'getClientMessageistBanner.action').query({
          _type: type,
          _userId: User.getCurrentUserId()
        })
      }
    }

  })

  .factory('getPersonalMenu', function () {
    var info = [{
      id: 1,
      iconLeftCss: ["ion-social-usd"],
      title: "账户余额: ",
      personalAttr: "balance",
      image: "./img/personal/sum.png"
    }, {
      id: 2,
      iconLeftCss: ["fa", "fa-diamond", "positive"],
      title: "账户积分: ",
      personalAttr: "integral",
      image: "./img/personal/integral.png"
    }, {
      id: 3,
      iconLeftCss: ["ion-person"],
      iconRightCss: ["ion-chevron-right", "icon-accessory"],
      title: "学员信息",
      href: '#tab/personal/studentInfo',
      image: "./img/personal/info.png"
    }, {
      id: 4,
      iconLeftCss: ["ion-clipboard"],
      iconRightCss: ["ion-chevron-right", "icon-accessory"],
      title: "我的课程表",
      href: '#tab/personal/classSchedule',
      image: "./img/personal/class.png"
    }, /* {
      id: 5,
      iconLeftCss: ["ion-android-list"],
      iconRightCss: ["ion-chevron-right", "icon-accessory"],
      title: "我的订单",
      href: '#tab/personal/myOrder',
      image: "./img/personal/order.png"
    },*/ {
      id: 6,
      iconLeftCss: ["ion-help-circled"],
      iconRightCss: ["ion-chevron-right", "icon-accessory"],
      title: "调查问卷",
      href: '#tab/personal/wjdc',
      image: "./img/personal/surve.png"
    }, {
      id: 7,
      iconLeftCss: ["ion-ios-pulse"],
      iconRightCss: ["ion-chevron-right", "icon-accessory"],
      title: "我的情商测试",
      href: '#tab/personal/qscs',
      image: "./img/personal/eq_text.png"
    }, {
      id: 8,
      iconLeftCss: ["ion-android-clipboard"],
      iconRightCss: ["ion-chevron-right", "icon-accessory"],
      title: "我的考勤记录",
      href: '#tab/personal/kqjl',
      image: "./img/personal/integral.png"
    }, {
      id: 9,
      href: '#tab/personal/settings',
      iconLeftCss: ["ion-android-settings"],
      iconRightCss: ["ion-chevron-right", "icon-accessory"],
      title: "设置",
      image: "./img/personal/set.png"
    }];
    return {
      all: function () {
        return info;
      },
      remove: function (item) {
        info.splice(info.indexOf(item), 1);
      },
      get: function (infoId) {
        for (var i = 0; i < info.length; i++) {
          if (info[i].id === parseInt(infoId)) {
            return info[i];
          }
        }
        return null;
      }
    }
  })
  //获取未读消息
  .factory('getUnReadCount', function ($resource, User, ENV) {
    return {
      get: function () {
        return $resource(ENV.api + 'getMessageUnReadCount.action').get({
          _userId: User.getCurrentUserId()
        })
      }
    }
  })
  //获取最新活动详情
  .factory('getNewActivityInfo', function ($resource, User, ENV) {
    return {
      get: function (id) {
        return $resource(ENV.api + 'getNewActivityInfo.action').get({
          _id: id,
          _userId: User.getCurrentUserId()
        })
      }
    }
  })



  //storage
  .factory('Storage', function () {
    "use strict";
    return {
      set: function (key, data) {
        return window.localStorage.setItem(key, window.JSON.stringify(data));
      },
      get: function (key) {

        return window.JSON.parse(window.localStorage.getItem(key));
      },
      remove: function (key) {
        return window.localStorage.removeItem(key);
      }
    };
  })

  .factory('User', function (Storage, $rootScope, $resource, ENV, $q, $filter, $ionicHistory) {
    var storageKey = 'user';
    var user = Storage.get(storageKey) || {};
    return {
      update: function () {
        return $resource(ENV.api + 'UpdateCurUserInfo.action').get({
          _userId: user.id
        }, function (response) {
          if (response && response.loginInfo && response.loginInfo.id) {
            response.loginInfo.avatar = "img/avatarPerson.png";
            response.loginInfo.balance = $filter('currency')(response.loginInfo.accountAmount, "¥ ", 2);
            response.loginInfo.integral = $filter('currency')(response.loginInfo.point || 0, "", 2);
            user = response.loginInfo;
            Storage.set(storageKey, user)
          } else {
            $rootScope.showToastMessage('获取个人信息失败')
          }
        }, function () {
          $rootScope.showNetworkAnomalyToastMessage();
        });
      },
      login: function (loginInfo) {
        //登录
        Storage.set(storageKey, loginInfo);
        user = loginInfo;
        $rootScope.isLogin = true;
      },
      logout: function () {
        user = {};
        Storage.remove(storageKey);
        $rootScope.isLogin = false;
      },
      getCurrentUserId: function () {
        var currentView = $ionicHistory.currentView();
        if (currentView != null && currentView.index !== 0) {
          $rootScope.verifyMessage();
        }
        return user.id;
      },
      getLoginId: function () {
        return user.id;
      },
      getCurrentUser: function () {
        var q = $q.defer();
        if (user && user.id) {
          this.update().$promise.finally(function () {
            q.resolve(user);
          });
        } else {
          $rootScope.isLogin = false;
          q.resolve(null);
        }
        return q.promise;
      }
    };
  })
  .factory('Login', function ($rootScope, User, $state, $ionicHistory, $q, $timeout, $resource, ENV, $window) {
    return {
      validUser: function (user) {
        var q = $q.defer();
        $resource(ENV.api + 'validUser.action').get({
          params: {
            userName: user.username,
            password: user.password
          }
        }, function (response) {

          if (response && response.result) {
            if (response.result === 'success') {
              $rootScope.isLogin = true;
              User.login(response.loginInfo);
              $ionicHistory.nextViewOptions({
                historyRoot: true
              });
              $state.go('tab.home', {reload: true}).then(function () {
                q.resolve(true);
              });
            } else {
              q.reject(false);
            }
            $rootScope.showToastMessage(response.msg);
          } else {
            $rootScope.showToastMessage('验证失败!');
            q.reject(false);
          }
          if (response && response.alias) {

            $window.plugins.jPushPlugin.resumePush();
            $window.plugins.jPushPlugin.setAlias({
              sequence: 1,
              alias: response.alias
            })
          }
        }, function (err) {
          $rootScope.showNetworkAnomalyToastMessage();
          q.reject(false);
        });
        return q.promise;
      }
    };
  })
  //app广告
  .factory("getAppAdvertisement", function ($resource, ENV) {
    return {
      get: function () {
        return $resource(ENV.api + 'getAppAdvertisement.action', {}, {
          get: {
            method: "get",
            isArray: false,
            timeout: 3000
          }
        }).get();
      }
    }

  })
  .factory('saveAppActivities', function ($resource, ENV) {
    return {
      save: function (_condition) {
        return $resource(ENV.api + 'saveAppBehaviorRecord.action').save(_condition);
      }
    }
  })

  //获取学生列表
  .factory('getStudentByparent', function ($resource, ENV, User) {
    return {
      query: function () {
        return $resource(ENV.api + 'getStudentByParent.action').query({
          _userId: User.getCurrentUserId()
        });
      }
    }
  })
  .factory('pay', function ($cordovaAlipay, getOrder, $rootScope, $ionicLoading, $state, $ionicHistory, $ionicPopup) {

    // 余额支付
    var balancePay = function (students, info, orderFuc, deductionAmount) {
      var currentView = $ionicHistory.currentView().url.split('/')[2];
      $ionicLoading.show();
      orderFuc(students, info, deductionAmount).$promise.then(function (payInfo) {
        if (payInfo.msgCode === "faile") {
          $ionicPopup.alert({
            template: payInfo.msgDesc || "订单出错"
          });
        } else if (payInfo.msgCode === "success") {
          $state.go('tab.' + currentView + '-payResult', {
            params: {
              resultStatus: 9000,
              resultMsg: payInfo.msgCode
            }
          });
        }
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $ionicLoading.hide();
      });
    }

    var alipay = function (students, info, orderFuc, deductionAmount) {
      var currentView = $ionicHistory.currentView().url.split('/')[2];
      $ionicLoading.show();
      orderFuc(students, info, deductionAmount).$promise.then(function (payInfo) {
        if (payInfo.msgCode === "faile") {
          $ionicPopup.alert({
            template: payInfo.msgDesc || "订单出错"
          });
        } else {
          cordova.plugins.alipay.payment
          (payInfo.order, function (success) {
            $state.go('tab.' + currentView + '-payResult', {
              params: success
            })
          }, function (err) {
            $state.go('tab.' + currentView + '-payResult', {
              params: err
            })
          });
        }
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $ionicLoading.hide();
      });
    };
    var wechatPay = function (students, info, orderFuc, deductionAmount) {
      var currentView = $ionicHistory.currentView().url.split('/')[2];
      $ionicLoading.show();
      orderFuc(students, info, deductionAmount).$promise.then(function (payInfo) {

        if (payInfo.msgCode === "faile") {
          $ionicPopup.alert({
            template: payInfo.msgDesc || "订单出错"
          });
        } else {
          var orderInfo = JSON.parse(payInfo.order);
          var params = {
            partnerid: orderInfo.partnerId, // merchant id
            prepayid: orderInfo.prepayId, // prepay id
            noncestr: orderInfo.nonceStr, // nonce
            timestamp: orderInfo.timeStamp, // timestamp
            sign: orderInfo.sign // signed string
          }
          Wechat.sendPaymentRequest
          (params, function (success) {
            $state.go('tab.' + currentView + '-payResult', {
              params: {
                resultStatus: 9000,
                resultMsg: success
              }
            })
          }, function (err) {
            $state.go('tab.' + currentView + '-payResult', {
              params: {
                resultMsg: err
              }
            })
          });
        }
      }).catch(function () {
        $rootScope.showNetworkAnomalyToastMessage();
      }).finally(function () {
        $ionicLoading.hide();
      });
    };
    return {
      alipay: alipay,
      wechatPay: wechatPay,
      balancePay: balancePay
    }
  })
  //支付宝订单
  .factory('getOrder', function (ENV, $resource, User, $rootScope) {
    return {
      activityOrder: function (students, info, deductionAmount) {
        return $resource(ENV.api + 'doActivityAliPay.action').get({
          _studentIds: students.join(",") + ",",
          _userId: User.getCurrentUserId(),
          _activityId: info.id,
          _balance: deductionAmount,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          pageCode: 'hdzf',
          openTime: moment().format('YYYY-MM-DD HH:mm:ss')
        })
      },
      courseOrder: function (students, info, deductionAmount) {
        return $resource(ENV.api + 'doCourseAliPay.action').get({
          _studentIds: students.join(",") + ",",
          _userId: User.getCurrentUserId(),
          _courseId: info.course_id,
          _coursePriceId: info.course_price_id,
          _price: info.price,
          _campId: info.id,
          _balance: deductionAmount,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          pageCode: 'bkzf',
          openTime: moment().format('YYYY-MM-DD HH:mm:ss')
        })
      }
    }
  })
  //微信订单
  .factory('getWecahtOrder', function (ENV, $resource, User, $rootScope) {
    return {
      activityOrder: function (students, info, deductionAmount) {
        return $resource(ENV.api + 'doActivityWeixinPay.action').get({
          _studentIds: students.join(",") + ",",
          _userId: User.getCurrentUserId(),
          _activityId: info.id,
          _balance: deductionAmount,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          pageCode: 'hdzf',
          openTime: moment().format('YYYY-MM-DD HH:mm:ss')
        })
      },
      courseOrder: function (students, info, deductionAmount) {
        return $resource(ENV.api + 'doCourseWeixinPay.action').get({
          _studentIds: students.join(",") + ",",
          _userId: User.getCurrentUserId(),
          _courseId: info.course_id,
          _coursePriceId: info.course_price_id,
          _price: info.price,
          _campId: info.id,
          _balance: deductionAmount,
          uuid: $rootScope.phone.uuid,
          model: $rootScope.phone.model,
          serial: $rootScope.phone.serial,
          pageCode: 'bkzf',
          openTime: moment().format('YYYY-MM-DD HH:mm:ss')
        })
      }
    }
  })
  //更新信息

  .factory('UpdateInfo', function ($resource, ENV) {
    return {
      updateIOS: function () {
        return $resource(ENV.iosUpdateUrl, {}, {
          query: {
            method: 'get',
            params: {
              id: ENV.iosAppKey
            },
            timeout: 4000
          }
        });
      },
      updateAll: function () {
        return $resource(ENV.api + 'queryNewestApk.action', {}, {
          query: {
            method: 'get',
            timeout: 4000
          }
        });
      }
    };
  })
  //消息聚集
  .factory('getGatherPushMessage', function (ENV, $resource, User) {
    return {
      queryGather: function (type) {
        return $resource(ENV.api + 'getGatherPushMessageList.action').query({
          _userId: User.getCurrentUserId(),
          _type: type
        })
      },
      queryGatherList: function (type, id) {
        return $resource(ENV.api + 'getNoTwPushMessageList.action').query({
          _userId: User.getCurrentUserId(),
          _type: type,
          _id: id || null,
          _queryCondition: null
        })
      }
    }
  })
  //软件更新
  .factory('updateApp', function ($cordovaAppVersion, UpdateInfo, $ionicPopup, $ionicLoading, $cordovaToast, ENV, $cordovaFileOpener, $cordovaInAppBrowser, popup) {
    // 检查更新
    function checkUpdate() {
      if (ionic.Platform.isAndroid()) {
        UpdateInfo.updateAll().query(function (r) {
          if (r != null && r.apk_version) {
            //从服务端获取最新版本
            var serverAppVersion = r.apk_version;
            //获取版本
            $cordovaAppVersion.getVersionNumber().then(function (version) {
              //如果本地与服务端的APP版本不符合
              if (version < serverAppVersion || (version != serverAppVersion && response.is_force_update == "是")) {
                showUpdateConfirm(r);
              }
            })
          }
          /* else {
                      $cordovaToast.showShortCenter('已经是最新版本!');
                    }*/
        })
      }
      else if (ionic.Platform.isIOS()) {
        UpdateInfo.updateAll().query(function (allResult) {
          if (allResult != null && allResult.apk_version) {
            //从服务端获取最新版本
            var serverAppVersion = allResult.apk_version;
            UpdateInfo.updateIOS().query(function (r) {
              if (r != null && r != "") {
                $cordovaAppVersion.getVersionNumber().then(function (version) {
                  //如果本地与服务端的APP版本不符合
                  if (version !== r.results[0].version && version !== serverAppVersion && allResult.is_force_update === "是") {
                    $ionicPopup.show({
                      template: allResult.content,
                      title: '应用必须更新才能使用',
                      cssClass: 'popup-list',
                      buttons: [
                        {
                          text: '<b>去更新</b>',
                          type: 'button-positive',
                          onTap: function (e) {
                            window.open(r.results[0].trackViewUrl, '_blank', 'location=yes');
                            e.preventDefault();
                          }
                        }
                      ]
                    });
                  }
                });
              }
            })
          }
        })
      }
    }

    // 显示是否更新对话框
    function showUpdateConfirm(response) {
      function update() {
        $ionicLoading.show({
          template: "已经下载：0%"
        });
        var path = (JSON.parse(response.apk)[0]).imgPath;
        var url = ENV.ipAddress + "projectdata/" + path;
        var trustHosts = true;
        var options = {};
        try {
          // 请求当前持久化的文件系统
          window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
            //请求成功   获取download文件夹 若不存在则创建该文件夹
            fileSystem.root.getDirectory('download', {//
              create: true,
              exclusive: false
            }, function (entry) {
              var targetPath = entry.toURL() + '//1.apk';
              //APP下载存放的路径，可以使用cordova file插件进行相关配置
              var fileTransfer = new FileTransfer();
              fileTransfer.onprogress = function (progress) {
                //进度，这里使用文字显示下载百分比
                var downloadProgress = (progress.loaded / progress.total) * 100;

                (function load() {
                  $ionicLoading.show({
                    template: "已经下载：" + Math.floor(downloadProgress) + "%"
                  });
                })();
                if (downloadProgress > 99 && response.is_force_update !== "是") {
                  $ionicLoading.hide();
                }
              };
              fileTransfer.download(url, targetPath, function (result) {
                // 打开下载下来的APP
                $cordovaFileOpener.open(targetPath, 'application/vnd.android.package-archive'
                ).then(function () {
                  // 成功
                }, function (err) {
                  // 错误
                });
                $ionicLoading.hide();
              }, function (err) {
                $ionicLoading.hide();
                popup.popupAlert({
                  template: "下载失败"
                }).then(function (res) {
                  if (response.is_force_update === "是") {
                    ionic.Platform.exitApp();
                  }
                })
              }, trustHosts, options)


            }, function () {
              alert('创建文件夹失败');
            });
          }, function () {
            alert('创建文件夹失败');
          });
        } catch (e) {
          alert('系统异常')
        }
      }

      var type = navigator.connection.type;
      $ionicPopup.confirm({
        title: type === "wifi" ? "" : '建议您在WIFI条件下进行升级，是否确认升级？',
        template: response.content,
        cssClass: 'popup-list',
        cancelText: response.is_force_update === "是" ? '退出' : '取消',
        cancelType: 'assertive-important',
        okText: '确定'
      }).then(function (res) {
        if (res) {
          update();
        } else {
          // 取消更新
          if (response.is_force_update === "是") {
            ionic.Platform.exitApp();
          }
        }
      });
    }

    return {
      checkUpdate: checkUpdate
    }
  })

  .directive('focus', function($timeout) {
    return {
      link: function(scope, element) {
        $timeout(function() {
          element[0].focus();
        }, 800);
      }
    };
  })

  //tabs class 添加{{$root.hideTabs}} 需要隐藏的页面 添加 hide-tabs
  //$destroy是监听页面触发的,$on接收父组件事件
  .directive('hideTabs', function ($rootScope) {
    return {
      restrict: 'A',
      link: function ($scope) {
        $scope.$on('$ionicView.beforeEnter', function () {
          $rootScope.hideTabs = 'tabs-item-hide';
        });
        /*     $scope.$on('$ionicView.afterEnter', function () {
               console.log('afterEnter')
               $rootScope.hideTabs = 'tabs-item-hide';
             });

             $scope.$on('$ionicView.leave', function () {
               console.log('leave')
               $rootScope.hideTabs = '';
             });*/
        /* $destroy在软件缓存视图情况下不会触发
         $scope.$on('$destroy', function () {
          })*/
      }
    };
  })
  //有时用返回键不会触发生命周期钩子
  .directive('showTabs', function ($rootScope) {
    return {
      restrict: 'A',
      link: function ($scope) {
        $scope.$on('$ionicView.loaded', function () {
          $rootScope.hideTabs = '';
        });
      }
    };
  })

  // slides-tabs
  .directive('onActiveTab', function ($ionicSlideBoxDelegate) {
    return {
      restrict: 'A',
      link: function (scope, element) {
        var thisSlider = $ionicSlideBoxDelegate.$getByHandle('sliderWatcher');
        scope.$on('slideBox.slideChanged', function (event, index) {
          for (var i = 0; i < element.children().length; i++) {
            if (i === index) {
              angular.element(element.children()[i]).addClass('active')
            } else {
              angular.element(element.children()[i]).removeClass('active')
            }
          }
        });
        element.bind('click', function () {
          var tabKey = event.target.attributes.tabKey.value;
          thisSlider.slide(tabKey - 1);
        })
      }
    };
  })
  .directive('swipers', function ($timeout, getBackgroundImgs, $state, $rootScope, $ionicHistory) {
    return {
      restrict: "E",
      scope: {
        mark: "@"
      },
      templateUrl: 'templates/swipers.html',
      link: function (scope, element, attrs) {
        scope.onBanner = function (item) {
          var temp = {
            id: item.id,
            content: [item]
          };
          switch (item.message_category) {
            case "lydt":
              $state.go('tab.home').then(function () {
                $state.go('tab.home-LYDTDetail', {
                  params: temp
                });
              });
              break;
            case "hd":
              $state.go('tab.home').then(function () {
                $state.go('tab.home-HDXQPage', {
                  params: temp
                });
              });
              break;
            case "kc":
              $state.go('tab.home').then(function () {
                $state.go('tab.home-LYDTDetail', {
                  params: temp
                });
              });
              break;
            case "fmkc":
              $state.go('tab.home').then(function () {
                $state.go('tab.home-FMKT-HDXQPage', {
                  params: temp
                });
              });
              break;
            default:
              if (item.url) {
                $state.go(item.url, {
                  params: item.params
                });
              }
          }
        };
        //banner
        /*  var timeout = $timeout(function () {
            scope.backgroundImgs = getBackgroundImgs.all();
            scope.initSwiper("");
          }, 2000);*/
        getBackgroundImgs.query(attrs.type || null).$promise.then(function (res) {
          var temp;
          scope.backgroundImgs = res.map(function (item) {
            temp = JSON.parse(item.content);
            temp[0].id = item.id;
            temp[0].message_category = item.message_category;
            return temp;
          });
          /*  if (res.length < 1) {
              scope.backgroundImgs = getBackgroundImgs.all();
            }*/
        }).catch(function () {
          // scope.backgroundImgs = getBackgroundImgs.all();
          $rootScope.showNetworkAnomalyToastMessage();
        }).finally(function () {
          // $timeout.cancel(timeout);
          scope.initSwiper(1);
        });

        scope.initSwiper = function (count) {
          scope.showSwiper = (count === 1);
          $timeout(function () {
            var swiper = new Swiper('#' + attrs.mark + count, { //轮播图绑定样式名
              pagination: {
                el: '.swiper-pagination',
                type: 'fraction',
                renderFraction: function (currentClass, totalClass) {
                  return '<span class="' + currentClass + '"></span>' + '/' + '<span class="' + totalClass + '"></span>';
                }
              },
              autoplay: {
                delay: 2500,
                disableOnInteraction: false
              },
              loop: true
            });
          }, 100);
        };
      }
    };
  })
  .directive('loading', function () {
    return {
      restrict: "E",
      scope: {
        loading: "="
      },
      templateUrl: 'templates/spinner.html'
    };
  })
  .directive('messageSwiper', function ($state, $rootScope, $timeout, getGatherPushMessage, $interval) {
    return {
      restrict: "E",
      scope: {
        mark: "@",
        type: "@",
        sref: '@'
      },
      templateUrl: 'templates/messageSwiper.html',
      link: function (scope, element, attrs) {
        scope.getType = {
          type: scope.type
        };
        var initSwiper = function () {
          var swiper = new Swiper('#' + attrs.mark, { //轮播图绑定样式名
            speed: 3000,
            noSwiping: true,
            autoplay: {
              delay: 2000,
              disableOnInteraction: false
            },
            loop: true
          });
          return swiper;
        };

        function init() {
          getGatherPushMessage.queryGather(scope.type || null).$promise.then(function (res) {
            var snapshot = JSON.parse(JSON.stringify(res));
            scope.list = res;

            function filterTime() {
              scope.list.forEach(function (item, index) {
                item.push_date = moment(snapshot[index].push_date).from(moment());
              })
            }

            //结束之前的轮询建立新的
            if ($rootScope.timeline) {
              $interval.cancel($rootScope.timeline);
            }
            filterTime();
            $rootScope.timeline = $interval(function () {
              filterTime();
            }, 60000);
            $timeout(function () {
              $rootScope.theSwiper = initSwiper();
              $rootScope.setMessage = function () {
                getGatherPushMessage.queryGather(scope.type || null).$promise.then(function (res) {
                  var snapshot = JSON.parse(JSON.stringify(res));

                  function filterTime() {
                    res.forEach(function (item, index) {
                      item.push_date = moment(snapshot[index].push_date).from(moment());
                    })
                  }

                  //结束之前的轮询建立新的
                  if ($rootScope.timeline) {
                    $interval.cancel($rootScope.timeline);
                  }
                  filterTime();
                  $rootScope.timeline = $interval(function () {
                    filterTime();
                  }, 60000);

                  // 不是双向绑定 重渲染会更新不了;
                  if (res.length) {
                    $rootScope.theSwiper.removeAllSlides();
                    var templates = res.map(function (item) {
                      return '<div class="swiper-slide swiper-no-swiping messageBox">\n' +
                        '        <div class="messageInfo">\n' +
                        '          <h4>' + item.data_name + '</h4>\n' +
                        '          <p>' + item.title + '</p>\n' +
                        '          <i class="item-note">' + item.push_date + '</i>\n' +
                        '\n' +
                        '        </div>\n' +
                        '      </div>'
                    });
                    $rootScope.theSwiper.appendSlide(templates);
                    $rootScope.theSwiper.autoplay.start()
                  }
                })
              }
            })
          }).catch(function () {
            $rootScope.showNetworkAnomalyToastMessage();
          });
        }

        init();

      }
    };
  })
  .filter('ToObject', function () {
    return function (input) {
      if (input.length > 0 && typeof input != 'object') {
        return JSON.parse(input);
      } else {
        return input || {};
      }
    }
  })
  .filter('MultiSelect', function () {
    return function (input, param1) {
      var partten = new RegExp("^" + param1 + "\\D|\\D" + param1 + "$|^" + param1 + "$|\\D" + param1 + "\\D");
      return partten.test(input)
    }
  })
  .filter('filterUrl', function ($sce) {
    return function (input, type) {
      return $sce.trustAs(type, input);
    }
  })

  // 实效性过滤
  .filter('filterTime', function () {
    return function (input) {
      return moment(input).from(moment())
    }
  })

  // 价格过滤
  .filter('filterPrice', function () {
    return function (input) {
      return input.toFixed(2);
    }
  })

  // 正则
  .filter('filterReg', function () {
    return function (input) {
      return input.replace(/\\/, '/');
    }
  })
;
